/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.emftext.language.refactoring.refactoring_specification;

import org.emftext.language.refactoring.roles.RoleAttribute;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>ASSIGN</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.emftext.language.refactoring.refactoring_specification.ASSIGN#getSourceAttribute <em>Source Attribute</em>}</li>
 *   <li>{@link org.emftext.language.refactoring.refactoring_specification.ASSIGN#getTargetAttribute <em>Target Attribute</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage#getASSIGN()
 * @model
 * @generated
 */
public interface ASSIGN extends AttributeCommand
{
  /**
   * Returns the value of the '<em><b>Source Attribute</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Source Attribute</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Source Attribute</em>' reference.
   * @see #setSourceAttribute(RoleAttribute)
   * @see org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage#getASSIGN_SourceAttribute()
   * @model
   * @generated
   */
  RoleAttribute getSourceAttribute();

  /**
   * Sets the value of the '{@link org.emftext.language.refactoring.refactoring_specification.ASSIGN#getSourceAttribute <em>Source Attribute</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Source Attribute</em>' reference.
   * @see #getSourceAttribute()
   * @generated
   */
  void setSourceAttribute(RoleAttribute value);

  /**
   * Returns the value of the '<em><b>Target Attribute</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Target Attribute</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Target Attribute</em>' reference.
   * @see #setTargetAttribute(RoleAttribute)
   * @see org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage#getASSIGN_TargetAttribute()
   * @model required="true"
   * @generated
   */
  RoleAttribute getTargetAttribute();

  /**
   * Sets the value of the '{@link org.emftext.language.refactoring.refactoring_specification.ASSIGN#getTargetAttribute <em>Target Attribute</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Target Attribute</em>' reference.
   * @see #getTargetAttribute()
   * @generated
   */
  void setTargetAttribute(RoleAttribute value);

} // ASSIGN
