/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.emftext.language.refactoring.refactoring_specification;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

import org.emftext.language.refactoring.roles.Role;
import org.emftext.language.refactoring.roles.RoleModel;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Refactoring Specification</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.emftext.language.refactoring.refactoring_specification.RefactoringSpecification#getUsedRoleModel <em>Used Role Model</em>}</li>
 *   <li>{@link org.emftext.language.refactoring.refactoring_specification.RefactoringSpecification#getInstructions <em>Instructions</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage#getRefactoringSpecification()
 * @model
 * @generated
 */
public interface RefactoringSpecification extends EObject
{
  /**
   * Returns the value of the '<em><b>Used Role Model</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Used Role Model</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Used Role Model</em>' reference.
   * @see #setUsedRoleModel(RoleModel)
   * @see org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage#getRefactoringSpecification_UsedRoleModel()
   * @model required="true"
   * @generated
   */
  RoleModel getUsedRoleModel();

  /**
   * Sets the value of the '{@link org.emftext.language.refactoring.refactoring_specification.RefactoringSpecification#getUsedRoleModel <em>Used Role Model</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Used Role Model</em>' reference.
   * @see #getUsedRoleModel()
   * @generated
   */
  void setUsedRoleModel(RoleModel value);

  /**
   * Returns the value of the '<em><b>Instructions</b></em>' containment reference list.
   * The list contents are of type {@link org.emftext.language.refactoring.refactoring_specification.Instruction}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Instructions</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Instructions</em>' containment reference list.
   * @see org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage#getRefactoringSpecification_Instructions()
   * @model containment="true"
   * @generated
   */
  EList<Instruction> getInstructions();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   * <!-- end-model-doc -->
   * @model kind="operation"
   *        annotation="http://www.eclipse.org/emf/2002/GenModel body='org.eclipse.emf.common.util.EList < org.emftext.language.refactoring.refactoring_specification.Variable> variables = new org.eclipse.emf.common.util.BasicEList < org.emftext.language.refactoring.refactoring_specification.Variable> ( ) ; \n\torg.eclipse.emf.common.util.EList < org.emftext.language.refactoring.refactoring_specification.Instruction> instructions = getInstructions ( ) ; \n\tfor ( org.emftext.language.refactoring.refactoring_specification.Instruction instruction : instructions ) { \n\t\tif ( instruction instanceof org.emftext.language.refactoring.refactoring_specification.VariableDeclarationCommand ) { \n\t\t\torg.emftext.language.refactoring.refactoring_specification.Variable var = ( ( org.emftext.language.refactoring.refactoring_specification.VariableDeclarationCommand ) instruction ) .getVariable ( ) ; \n\t\t\tif ( var != null ) { \n\t\t\t\tvariables .add ( var ) ; \n\t\t\t} \n\t\t} \n\t} \n\treturn variables ;'"
   * @generated
   */
  EList<Variable> getDeclaredVariables();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   * <!-- end-model-doc -->
   * @model annotation="http://www.eclipse.org/emf/2002/GenModel body='org.eclipse.emf.common.util.EList < org.emftext.language.refactoring.refactoring_specification.Variable > variables = getDeclaredVariables ( ) ; \n\tfor ( org.emftext.language.refactoring.refactoring_specification.Variable variable : variables ) { \n\t\tif ( variable .getName ( ) .equals ( name ) ) { \n\t\t\treturn variable ; \n\t\t} \n\t} \n\treturn null ;'"
   * @generated
   */
  Variable getVariableByName(String name);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   * <!-- end-model-doc -->
   * @model annotation="http://www.eclipse.org/emf/2002/GenModel body='java.util.Set< org.emftext.language.refactoring.refactoring_specification.Instruction> instructions = new java.util.LinkedHashSet< org.emftext.language.refactoring.refactoring_specification.Instruction>();\njava.util.List< org.emftext.language.refactoring.refactoring_specification.Instruction> usedInstructions = getInstructions();\nfor ( org.emftext.language.refactoring.refactoring_specification.Instruction instruction : usedInstructions) {\n\tboolean isReferencingObject = isRoleReferencedByObject(referencedRole, instruction);\n\tif (isReferencingObject) {\n\t\tinstructions.add(instruction);\n\t}\n\torg.eclipse.emf.common.util.TreeIterator< org.eclipse.emf.ecore.EObject> iterator = org.eclipse.emf.ecore.util.EcoreUtil.getAllContents(instruction, true);\n\twhile (iterator.hasNext()) {\n\t\torg.eclipse.emf.ecore.EObject eObject = ( org.eclipse.emf.ecore.EObject) iterator.next();\n\t\tisReferencingObject = isRoleReferencedByObject(referencedRole, eObject);\n\t\tif (isReferencingObject) {\n\t\t\tinstructions.add(instruction);\n\t\t}\n\t}\n}\nreturn new org.eclipse.emf.common.util.BasicEList< org.emftext.language.refactoring.refactoring_specification.Instruction>(instructions);'"
   * @generated
   */
  EList<Instruction> getInstructionsReferencingRole(Role referencedRole);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   * <!-- end-model-doc -->
   * @model required="true"
   *        annotation="http://www.eclipse.org/emf/2002/GenModel body='org.eclipse.emf.ecore.EClass metaclass = eObject.eClass();\njava.util.List< org.eclipse.emf.ecore.EReference> references = metaclass.getEAllReferences();\nfor ( org.eclipse.emf.ecore.EReference reference : references) {\n\tif (!reference.isContainment()) {\n\t\torg.eclipse.emf.ecore.EClassifier classifier = reference.getEType();\n\t\tif (classifier.isInstance(referencedRole)) {\n\t\t\tjava.lang.Object value = eObject.eGet(reference);\n\t\t\tif (value instanceof org.emftext.language.refactoring.roles.Role) {\n\t\t\t\tif ((( org.emftext.language.refactoring.roles.Role) value).equals(referencedRole)) {\n\t\t\t\t\treturn true;\n\t\t\t\t}\n\t\t\t} else if (value instanceof java.util.List<?>) {\n\t\t\t\tfor ( java.lang.Object listObject : ( java.util.List<?>) value) {\n\t\t\t\t\tif (listObject.equals(referencedRole)) {\n\t\t\t\t\t\treturn true;\n\t\t\t\t\t}\n\t\t\t\t}\n\t\t\t}\n\t\t}\n\t}\n}\nreturn false;'"
   * @generated
   */
  boolean isRoleReferencedByObject(Role referencedRole, EObject eObject);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   * <!-- end-model-doc -->
   * @model kind="operation"
   *        annotation="http://www.eclipse.org/emf/2002/GenModel body='java.util.List < org.emftext.language.refactoring.refactoring_specification.IndexVariable> variables = new java.util.ArrayList< org.emftext.language.refactoring.refactoring_specification.IndexVariable>(); \n\torg.eclipse.emf.common.util.EList < org.emftext.language.refactoring.refactoring_specification.Instruction> instructions = getInstructions ( ) ; \n\tfor ( org.emftext.language.refactoring.refactoring_specification.Instruction instruction : instructions){ \n\t\tif (instruction instanceof org.emftext.language.refactoring.refactoring_specification.IndexAssignmentCommand) { \n\t\t\torg.emftext.language.refactoring.refactoring_specification.IndexVariable var = (( org.emftext.language.refactoring.refactoring_specification.IndexAssignmentCommand) instruction).getVariable(); \n\t\t\tif (var != null) { \n\t\t\t\tvariables.add(var); \n\t\t\t} \n\t\t} \n\t} \n\treturn new org.eclipse.emf.common.util.BasicEList< org.emftext.language.refactoring.refactoring_specification.IndexVariable>(variables);'"
   * @generated
   */
  EList<IndexVariable> getDeclaredIndexVariables();

} // RefactoringSpecification
