/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.emftext.language.refactoring.refactoring_specification;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Variable</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.emftext.language.refactoring.refactoring_specification.Variable#getContainerCommand <em>Container Command</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage#getVariable()
 * @model
 * @generated
 */
public interface Variable extends AbstractVariable
{
  /**
   * Returns the value of the '<em><b>Container Command</b></em>' container reference.
   * It is bidirectional and its opposite is '{@link org.emftext.language.refactoring.refactoring_specification.VariableDeclarationCommand#getVariable <em>Variable</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Container Command</em>' container reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Container Command</em>' container reference.
   * @see #setContainerCommand(VariableDeclarationCommand)
   * @see org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage#getVariable_ContainerCommand()
   * @see org.emftext.language.refactoring.refactoring_specification.VariableDeclarationCommand#getVariable
   * @model opposite="variable" required="true" transient="false"
   * @generated
   */
  VariableDeclarationCommand getContainerCommand();

  /**
   * Sets the value of the '{@link org.emftext.language.refactoring.refactoring_specification.Variable#getContainerCommand <em>Container Command</em>}' container reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Container Command</em>' container reference.
   * @see #getContainerCommand()
   * @generated
   */
  void setContainerCommand(VariableDeclarationCommand value);

} // Variable
