/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.emftext.language.refactoring.refactoring_specification.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.emftext.language.refactoring.refactoring_specification.ASSIGN;
import org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage;

import org.emftext.language.refactoring.roles.RoleAttribute;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>ASSIGN</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.emftext.language.refactoring.refactoring_specification.impl.ASSIGNImpl#getSourceAttribute <em>Source Attribute</em>}</li>
 *   <li>{@link org.emftext.language.refactoring.refactoring_specification.impl.ASSIGNImpl#getTargetAttribute <em>Target Attribute</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ASSIGNImpl extends AttributeCommandImpl implements ASSIGN
{
  /**
   * The cached value of the '{@link #getSourceAttribute() <em>Source Attribute</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSourceAttribute()
   * @generated
   * @ordered
   */
  protected RoleAttribute sourceAttribute;

  /**
   * The cached value of the '{@link #getTargetAttribute() <em>Target Attribute</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTargetAttribute()
   * @generated
   * @ordered
   */
  protected RoleAttribute targetAttribute;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ASSIGNImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return RefactoringSpecificationPackage.Literals.ASSIGN;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public RoleAttribute getSourceAttribute()
  {
    if (sourceAttribute != null && sourceAttribute.eIsProxy())
    {
      InternalEObject oldSourceAttribute = (InternalEObject)sourceAttribute;
      sourceAttribute = (RoleAttribute)eResolveProxy(oldSourceAttribute);
      if (sourceAttribute != oldSourceAttribute)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, RefactoringSpecificationPackage.ASSIGN__SOURCE_ATTRIBUTE, oldSourceAttribute, sourceAttribute));
      }
    }
    return sourceAttribute;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public RoleAttribute basicGetSourceAttribute()
  {
    return sourceAttribute;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setSourceAttribute(RoleAttribute newSourceAttribute)
  {
    RoleAttribute oldSourceAttribute = sourceAttribute;
    sourceAttribute = newSourceAttribute;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, RefactoringSpecificationPackage.ASSIGN__SOURCE_ATTRIBUTE, oldSourceAttribute, sourceAttribute));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public RoleAttribute getTargetAttribute()
  {
    if (targetAttribute != null && targetAttribute.eIsProxy())
    {
      InternalEObject oldTargetAttribute = (InternalEObject)targetAttribute;
      targetAttribute = (RoleAttribute)eResolveProxy(oldTargetAttribute);
      if (targetAttribute != oldTargetAttribute)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, RefactoringSpecificationPackage.ASSIGN__TARGET_ATTRIBUTE, oldTargetAttribute, targetAttribute));
      }
    }
    return targetAttribute;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public RoleAttribute basicGetTargetAttribute()
  {
    return targetAttribute;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTargetAttribute(RoleAttribute newTargetAttribute)
  {
    RoleAttribute oldTargetAttribute = targetAttribute;
    targetAttribute = newTargetAttribute;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, RefactoringSpecificationPackage.ASSIGN__TARGET_ATTRIBUTE, oldTargetAttribute, targetAttribute));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case RefactoringSpecificationPackage.ASSIGN__SOURCE_ATTRIBUTE:
        if (resolve) return getSourceAttribute();
        return basicGetSourceAttribute();
      case RefactoringSpecificationPackage.ASSIGN__TARGET_ATTRIBUTE:
        if (resolve) return getTargetAttribute();
        return basicGetTargetAttribute();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case RefactoringSpecificationPackage.ASSIGN__SOURCE_ATTRIBUTE:
        setSourceAttribute((RoleAttribute)newValue);
        return;
      case RefactoringSpecificationPackage.ASSIGN__TARGET_ATTRIBUTE:
        setTargetAttribute((RoleAttribute)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case RefactoringSpecificationPackage.ASSIGN__SOURCE_ATTRIBUTE:
        setSourceAttribute((RoleAttribute)null);
        return;
      case RefactoringSpecificationPackage.ASSIGN__TARGET_ATTRIBUTE:
        setTargetAttribute((RoleAttribute)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case RefactoringSpecificationPackage.ASSIGN__SOURCE_ATTRIBUTE:
        return sourceAttribute != null;
      case RefactoringSpecificationPackage.ASSIGN__TARGET_ATTRIBUTE:
        return targetAttribute != null;
    }
    return super.eIsSet(featureID);
  }

} //ASSIGNImpl
