/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.emftext.language.refactoring.rolemapping;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

import org.emftext.language.refactoring.roles.MultiplicityCollaboration;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Collaboration Mapping</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.emftext.language.refactoring.rolemapping.CollaborationMapping#getCollaboration <em>Collaboration</em>}</li>
 *   <li>{@link org.emftext.language.refactoring.rolemapping.CollaborationMapping#getReferenceMetaClassPair <em>Reference Meta Class Pair</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.emftext.language.refactoring.rolemapping.RolemappingPackage#getCollaborationMapping()
 * @model
 * @generated
 */
public interface CollaborationMapping extends EObject
{
  /**
   * Returns the value of the '<em><b>Collaboration</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Collaboration</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Collaboration</em>' reference.
   * @see #setCollaboration(MultiplicityCollaboration)
   * @see org.emftext.language.refactoring.rolemapping.RolemappingPackage#getCollaborationMapping_Collaboration()
   * @model required="true"
   * @generated
   */
  MultiplicityCollaboration getCollaboration();

  /**
   * Sets the value of the '{@link org.emftext.language.refactoring.rolemapping.CollaborationMapping#getCollaboration <em>Collaboration</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Collaboration</em>' reference.
   * @see #getCollaboration()
   * @generated
   */
  void setCollaboration(MultiplicityCollaboration value);

  /**
   * Returns the value of the '<em><b>Reference Meta Class Pair</b></em>' containment reference list.
   * The list contents are of type {@link org.emftext.language.refactoring.rolemapping.ReferenceMetaClassPair}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Reference Meta Class Pair</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Reference Meta Class Pair</em>' containment reference list.
   * @see org.emftext.language.refactoring.rolemapping.RolemappingPackage#getCollaborationMapping_ReferenceMetaClassPair()
   * @model containment="true" required="true"
   * @generated
   */
  EList<ReferenceMetaClassPair> getReferenceMetaClassPair();

} // CollaborationMapping
