/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.emftext.language.refactoring.rolemapping;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

import org.emftext.language.refactoring.roles.MultiplicityCollaboration;
import org.emftext.language.refactoring.roles.Role;
import org.emftext.language.refactoring.roles.RoleAttribute;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Concrete Mapping</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.emftext.language.refactoring.rolemapping.ConcreteMapping#getRole <em>Role</em>}</li>
 *   <li>{@link org.emftext.language.refactoring.rolemapping.ConcreteMapping#getMetaclass <em>Metaclass</em>}</li>
 *   <li>{@link org.emftext.language.refactoring.rolemapping.ConcreteMapping#getCollaborationMappings <em>Collaboration Mappings</em>}</li>
 *   <li>{@link org.emftext.language.refactoring.rolemapping.ConcreteMapping#getAttributeMappings <em>Attribute Mappings</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.emftext.language.refactoring.rolemapping.RolemappingPackage#getConcreteMapping()
 * @model
 * @generated
 */
public interface ConcreteMapping extends EObject
{
  /**
   * Returns the value of the '<em><b>Role</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Role</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Role</em>' reference.
   * @see #setRole(Role)
   * @see org.emftext.language.refactoring.rolemapping.RolemappingPackage#getConcreteMapping_Role()
   * @model required="true"
   * @generated
   */
  Role getRole();

  /**
   * Sets the value of the '{@link org.emftext.language.refactoring.rolemapping.ConcreteMapping#getRole <em>Role</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Role</em>' reference.
   * @see #getRole()
   * @generated
   */
  void setRole(Role value);

  /**
   * Returns the value of the '<em><b>Metaclass</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Metaclass</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Metaclass</em>' reference.
   * @see #setMetaclass(EClass)
   * @see org.emftext.language.refactoring.rolemapping.RolemappingPackage#getConcreteMapping_Metaclass()
   * @model required="true"
   * @generated
   */
  EClass getMetaclass();

  /**
   * Sets the value of the '{@link org.emftext.language.refactoring.rolemapping.ConcreteMapping#getMetaclass <em>Metaclass</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Metaclass</em>' reference.
   * @see #getMetaclass()
   * @generated
   */
  void setMetaclass(EClass value);

  /**
   * Returns the value of the '<em><b>Collaboration Mappings</b></em>' containment reference list.
   * The list contents are of type {@link org.emftext.language.refactoring.rolemapping.CollaborationMapping}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Collaboration Mappings</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Collaboration Mappings</em>' containment reference list.
   * @see org.emftext.language.refactoring.rolemapping.RolemappingPackage#getConcreteMapping_CollaborationMappings()
   * @model containment="true"
   * @generated
   */
  EList<CollaborationMapping> getCollaborationMappings();

  /**
   * Returns the value of the '<em><b>Attribute Mappings</b></em>' containment reference list.
   * The list contents are of type {@link org.emftext.language.refactoring.rolemapping.AttributeMapping}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Attribute Mappings</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Attribute Mappings</em>' containment reference list.
   * @see org.emftext.language.refactoring.rolemapping.RolemappingPackage#getConcreteMapping_AttributeMappings()
   * @model containment="true"
   * @generated
   */
  EList<AttributeMapping> getAttributeMappings();

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   * <!-- end-model-doc -->
   * @model required="true"
   *        annotation="http://www.eclipse.org/emf/2002/GenModel body='org.eclipse.emf.common.util.EList < org.emftext.language.refactoring.rolemapping.CollaborationMapping >mappings = getCollaborationMappings();\r\nfor ( org.emftext.language.refactoring.rolemapping.CollaborationMapping relationMapping:mappings) {\r\n\torg.eclipse.emf.ecore.util.EcoreUtil .resolveAll(relationMapping);\r\n\torg.emftext.language.refactoring.roles.MultiplicityCollaboration collaboration = relationMapping.getCollaboration();\r\n\tif (collaboration.getTarget().equals(role)) {\r\n\t\treturn relationMapping;\r\n\t}\r\n}\r\nreturn null;\r\n'"
   * @generated
   */
  CollaborationMapping getCollaborationMappingForTargetRole(Role role);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   * <!-- end-model-doc -->
   * @model required="true"
   *        annotation="http://www.eclipse.org/emf/2002/GenModel body='if (attribute == null) {\r\n\treturn null;\r\n}\r\njava.util.List < org.emftext.language.refactoring.rolemapping.AttributeMapping >attributeMappings = getAttributeMappings();\r\nfor ( org.emftext.language.refactoring.rolemapping.AttributeMapping attributeMapping:attributeMappings) {\r\n\tif (attributeMapping.getRoleAttribute().equals(attribute)) {\r\n\t\treturn attributeMapping;\r\n\t}\r\n}\r\nreturn null;\r\n'"
   * @generated
   */
  AttributeMapping getAttributeMappingForAttribute(RoleAttribute attribute);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   * <!-- end-model-doc -->
   * @model required="true"
   *        annotation="http://www.eclipse.org/emf/2002/GenModel body='java.util.List < org.emftext.language.refactoring.rolemapping.CollaborationMapping >relationMappings = getCollaborationMappings();\r\nfor ( org.emftext.language.refactoring.rolemapping.CollaborationMapping collaborationMapping:relationMappings) {\r\n\torg.emftext.language.refactoring.roles.MultiplicityCollaboration mappedCollaboration = collaborationMapping.getCollaboration();\r\n\tif (mappedCollaboration.equals(collaboration)) {\r\n\t\treturn collaborationMapping;\r\n\t}\r\n}\r\nreturn null;\r\n'"
   * @generated
   */
  CollaborationMapping getCollaborationMappingForCollaboration(MultiplicityCollaboration collaboration);

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * <!-- begin-model-doc -->
   * 
   * <!-- end-model-doc -->
   * @model annotation="http://www.eclipse.org/emf/2002/GenModel body='org.eclipse.emf.common.util.EList < org.emftext.language.refactoring.rolemapping.CollaborationMapping >mappings = getCollaborationMappings();\r\norg.eclipse.emf.common.util.EList < org.emftext.language.refactoring.rolemapping.CollaborationMapping >targetMappings = new org.eclipse.emf.common.util.BasicEList < org.emftext.language.refactoring.rolemapping.CollaborationMapping >();\r\nfor ( org.emftext.language.refactoring.rolemapping.CollaborationMapping relationMapping:mappings) {\r\n\torg.eclipse.emf.ecore.util.EcoreUtil .resolveAll(relationMapping);\r\n\torg.emftext.language.refactoring.roles.MultiplicityCollaboration collaboration = relationMapping.getCollaboration();\r\n\tif (collaboration.getTarget().equals(role)) {\r\n\t\ttargetMappings.add(relationMapping);\r\n\t}\r\n}\r\nreturn targetMappings;\r\n'"
   * @generated
   */
  EList<CollaborationMapping> getCollaborationMappingsForTargetRole(Role role);

} // ConcreteMapping
