/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.emftext.language.refactoring.rolemapping;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Reference Meta Class Pair</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.emftext.language.refactoring.rolemapping.ReferenceMetaClassPair#getReference <em>Reference</em>}</li>
 *   <li>{@link org.emftext.language.refactoring.rolemapping.ReferenceMetaClassPair#getMetaClass <em>Meta Class</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.emftext.language.refactoring.rolemapping.RolemappingPackage#getReferenceMetaClassPair()
 * @model
 * @generated
 */
public interface ReferenceMetaClassPair extends EObject
{
  /**
   * Returns the value of the '<em><b>Reference</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Reference</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Reference</em>' reference.
   * @see #setReference(EReference)
   * @see org.emftext.language.refactoring.rolemapping.RolemappingPackage#getReferenceMetaClassPair_Reference()
   * @model required="true"
   * @generated
   */
  EReference getReference();

  /**
   * Sets the value of the '{@link org.emftext.language.refactoring.rolemapping.ReferenceMetaClassPair#getReference <em>Reference</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Reference</em>' reference.
   * @see #getReference()
   * @generated
   */
  void setReference(EReference value);

  /**
   * Returns the value of the '<em><b>Meta Class</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Meta Class</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Meta Class</em>' reference.
   * @see #setMetaClass(EClass)
   * @see org.emftext.language.refactoring.rolemapping.RolemappingPackage#getReferenceMetaClassPair_MetaClass()
   * @model
   * @generated
   */
  EClass getMetaClass();

  /**
   * Sets the value of the '{@link org.emftext.language.refactoring.rolemapping.ReferenceMetaClassPair#getMetaClass <em>Meta Class</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Meta Class</em>' reference.
   * @see #getMetaClass()
   * @generated
   */
  void setMetaClass(EClass value);

} // ReferenceMetaClassPair
