/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.emftext.language.refactoring.rolemapping;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Role Mapping Model</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.emftext.language.refactoring.rolemapping.RoleMappingModel#getTargetMetamodel <em>Target Metamodel</em>}</li>
 *   <li>{@link org.emftext.language.refactoring.rolemapping.RoleMappingModel#getMappings <em>Mappings</em>}</li>
 *   <li>{@link org.emftext.language.refactoring.rolemapping.RoleMappingModel#getImports <em>Imports</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.emftext.language.refactoring.rolemapping.RolemappingPackage#getRoleMappingModel()
 * @model
 * @generated
 */
public interface RoleMappingModel extends EObject
{
  /**
   * Returns the value of the '<em><b>Target Metamodel</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Target Metamodel</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Target Metamodel</em>' reference.
   * @see #setTargetMetamodel(EPackage)
   * @see org.emftext.language.refactoring.rolemapping.RolemappingPackage#getRoleMappingModel_TargetMetamodel()
   * @model required="true"
   * @generated
   */
  EPackage getTargetMetamodel();

  /**
   * Sets the value of the '{@link org.emftext.language.refactoring.rolemapping.RoleMappingModel#getTargetMetamodel <em>Target Metamodel</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Target Metamodel</em>' reference.
   * @see #getTargetMetamodel()
   * @generated
   */
  void setTargetMetamodel(EPackage value);

  /**
   * Returns the value of the '<em><b>Mappings</b></em>' containment reference list.
   * The list contents are of type {@link org.emftext.language.refactoring.rolemapping.RoleMapping}.
   * It is bidirectional and its opposite is '{@link org.emftext.language.refactoring.rolemapping.RoleMapping#getOwningMappingModel <em>Owning Mapping Model</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Mappings</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Mappings</em>' containment reference list.
   * @see org.emftext.language.refactoring.rolemapping.RolemappingPackage#getRoleMappingModel_Mappings()
   * @see org.emftext.language.refactoring.rolemapping.RoleMapping#getOwningMappingModel
   * @model opposite="owningMappingModel" containment="true" required="true"
   * @generated
   */
  EList<RoleMapping> getMappings();

  /**
   * Returns the value of the '<em><b>Imports</b></em>' reference list.
   * The list contents are of type {@link org.eclipse.emf.ecore.EPackage}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Imports</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Imports</em>' reference list.
   * @see org.emftext.language.refactoring.rolemapping.RolemappingPackage#getRoleMappingModel_Imports()
   * @model
   * @generated
   */
  EList<EPackage> getImports();

} // RoleMappingModel
