/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.emftext.language.refactoring.rolemapping.resource.rolemapping.grammar;

/**
 * This class provides the follow sets for all terminals of the grammar. These
 * sets are used during code completion.
 */
public class RolemappingFollowSetProvider {
	
	public final static org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingExpectedElement TERMINALS[] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingExpectedElement[30];
	
	public final static org.eclipse.emf.ecore.EStructuralFeature[] FEATURES = new org.eclipse.emf.ecore.EStructuralFeature[5];
	
	public final static org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature[] LINKS = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature[23];
	
	public final static org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature[] EMPTY_LINK_ARRAY = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature[0];
	
	public static void initializeTerminals0() {
		TERMINALS[0] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingExpectedCsString(org.emftext.language.refactoring.rolemapping.resource.rolemapping.grammar.RolemappingGrammarInformationProvider.ROLEMAPPING_0_0_0_0);
		TERMINALS[1] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingExpectedCsString(org.emftext.language.refactoring.rolemapping.resource.rolemapping.grammar.RolemappingGrammarInformationProvider.ROLEMAPPING_0_0_0_2);
		TERMINALS[2] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingExpectedStructuralFeature(org.emftext.language.refactoring.rolemapping.resource.rolemapping.grammar.RolemappingGrammarInformationProvider.ROLEMAPPING_0_0_0_4);
		TERMINALS[3] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingExpectedCsString(org.emftext.language.refactoring.rolemapping.resource.rolemapping.grammar.RolemappingGrammarInformationProvider.ROLEMAPPING_0_0_0_5_0_0_1);
		TERMINALS[4] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingExpectedStructuralFeature(org.emftext.language.refactoring.rolemapping.resource.rolemapping.grammar.RolemappingGrammarInformationProvider.ROLEMAPPING_1_0_0_0_0_0_0);
		TERMINALS[5] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingExpectedStructuralFeature(org.emftext.language.refactoring.rolemapping.resource.rolemapping.grammar.RolemappingGrammarInformationProvider.ROLEMAPPING_1_0_0_0_0_1_0);
		TERMINALS[6] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingExpectedStructuralFeature(org.emftext.language.refactoring.rolemapping.resource.rolemapping.grammar.RolemappingGrammarInformationProvider.ROLEMAPPING_0_0_0_5_0_0_2_0_0_0);
		TERMINALS[7] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingExpectedCsString(org.emftext.language.refactoring.rolemapping.resource.rolemapping.grammar.RolemappingGrammarInformationProvider.ROLEMAPPING_1_0_0_2);
		TERMINALS[8] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingExpectedStructuralFeature(org.emftext.language.refactoring.rolemapping.resource.rolemapping.grammar.RolemappingGrammarInformationProvider.ROLEMAPPING_1_0_0_4);
		TERMINALS[9] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingExpectedCsString(org.emftext.language.refactoring.rolemapping.resource.rolemapping.grammar.RolemappingGrammarInformationProvider.ROLEMAPPING_1_0_0_6);
		TERMINALS[10] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingExpectedStructuralFeature(org.emftext.language.refactoring.rolemapping.resource.rolemapping.grammar.RolemappingGrammarInformationProvider.ROLEMAPPING_2_0_0_0);
		TERMINALS[11] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingExpectedCsString(org.emftext.language.refactoring.rolemapping.resource.rolemapping.grammar.RolemappingGrammarInformationProvider.ROLEMAPPING_1_0_0_11);
		TERMINALS[12] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingExpectedCsString(org.emftext.language.refactoring.rolemapping.resource.rolemapping.grammar.RolemappingGrammarInformationProvider.ROLEMAPPING_2_0_0_1);
		TERMINALS[13] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingExpectedStructuralFeature(org.emftext.language.refactoring.rolemapping.resource.rolemapping.grammar.RolemappingGrammarInformationProvider.ROLEMAPPING_2_0_0_2);
		TERMINALS[14] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingExpectedCsString(org.emftext.language.refactoring.rolemapping.resource.rolemapping.grammar.RolemappingGrammarInformationProvider.ROLEMAPPING_2_0_0_3_0_0_0);
		TERMINALS[15] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingExpectedCsString(org.emftext.language.refactoring.rolemapping.resource.rolemapping.grammar.RolemappingGrammarInformationProvider.ROLEMAPPING_2_0_0_4_0_0_0);
		TERMINALS[16] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingExpectedCsString(org.emftext.language.refactoring.rolemapping.resource.rolemapping.grammar.RolemappingGrammarInformationProvider.ROLEMAPPING_2_0_0_5);
		TERMINALS[17] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingExpectedStructuralFeature(org.emftext.language.refactoring.rolemapping.resource.rolemapping.grammar.RolemappingGrammarInformationProvider.ROLEMAPPING_5_0_0_0);
		TERMINALS[18] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingExpectedCsString(org.emftext.language.refactoring.rolemapping.resource.rolemapping.grammar.RolemappingGrammarInformationProvider.ROLEMAPPING_2_0_0_3_0_0_2_0_0_0);
		TERMINALS[19] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingExpectedCsString(org.emftext.language.refactoring.rolemapping.resource.rolemapping.grammar.RolemappingGrammarInformationProvider.ROLEMAPPING_2_0_0_3_0_0_3);
		TERMINALS[20] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingExpectedStructuralFeature(org.emftext.language.refactoring.rolemapping.resource.rolemapping.grammar.RolemappingGrammarInformationProvider.ROLEMAPPING_3_0_0_0);
		TERMINALS[21] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingExpectedCsString(org.emftext.language.refactoring.rolemapping.resource.rolemapping.grammar.RolemappingGrammarInformationProvider.ROLEMAPPING_2_0_0_4_0_0_3);
		TERMINALS[22] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingExpectedCsString(org.emftext.language.refactoring.rolemapping.resource.rolemapping.grammar.RolemappingGrammarInformationProvider.ROLEMAPPING_3_0_0_1);
		TERMINALS[23] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingExpectedStructuralFeature(org.emftext.language.refactoring.rolemapping.resource.rolemapping.grammar.RolemappingGrammarInformationProvider.ROLEMAPPING_4_0_0_0);
		TERMINALS[24] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingExpectedCsString(org.emftext.language.refactoring.rolemapping.resource.rolemapping.grammar.RolemappingGrammarInformationProvider.ROLEMAPPING_3_0_0_3_0_0_0);
		TERMINALS[25] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingExpectedCsString(org.emftext.language.refactoring.rolemapping.resource.rolemapping.grammar.RolemappingGrammarInformationProvider.ROLEMAPPING_3_0_0_4);
		TERMINALS[26] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingExpectedCsString(org.emftext.language.refactoring.rolemapping.resource.rolemapping.grammar.RolemappingGrammarInformationProvider.ROLEMAPPING_4_0_0_1_0_0_0);
		TERMINALS[27] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingExpectedStructuralFeature(org.emftext.language.refactoring.rolemapping.resource.rolemapping.grammar.RolemappingGrammarInformationProvider.ROLEMAPPING_4_0_0_1_0_0_1);
		TERMINALS[28] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingExpectedCsString(org.emftext.language.refactoring.rolemapping.resource.rolemapping.grammar.RolemappingGrammarInformationProvider.ROLEMAPPING_5_0_0_1);
		TERMINALS[29] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingExpectedStructuralFeature(org.emftext.language.refactoring.rolemapping.resource.rolemapping.grammar.RolemappingGrammarInformationProvider.ROLEMAPPING_5_0_0_2);
	}
	
	public static void initializeTerminals() {
		initializeTerminals0();
	}
	
	public static void initializeFeatures0() {
		FEATURES[0] = org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getRoleMappingModel().getEStructuralFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.ROLE_MAPPING_MODEL__MAPPINGS);
		FEATURES[1] = org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getRoleMapping().getEStructuralFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.ROLE_MAPPING__ROLE_TO_METAELEMENT);
		FEATURES[2] = org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getConcreteMapping().getEStructuralFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.CONCRETE_MAPPING__ATTRIBUTE_MAPPINGS);
		FEATURES[3] = org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getConcreteMapping().getEStructuralFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.CONCRETE_MAPPING__COLLABORATION_MAPPINGS);
		FEATURES[4] = org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getCollaborationMapping().getEStructuralFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.COLLABORATION_MAPPING__REFERENCE_META_CLASS_PAIR);
	}
	
	public static void initializeFeatures() {
		initializeFeatures0();
	}
	
	public static void initializeLinks0() {
		LINKS[0] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getRoleMapping(), FEATURES[0]);
		LINKS[1] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getRoleMapping(), FEATURES[0]);
		LINKS[2] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getRoleMapping(), FEATURES[0]);
		LINKS[3] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getRoleMapping(), FEATURES[0]);
		LINKS[4] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getRoleMapping(), FEATURES[0]);
		LINKS[5] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getRoleMapping(), FEATURES[0]);
		LINKS[6] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getRoleMapping(), FEATURES[0]);
		LINKS[7] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getRoleMapping(), FEATURES[0]);
		LINKS[8] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getRoleMapping(), FEATURES[0]);
		LINKS[9] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getRoleMapping(), FEATURES[0]);
		LINKS[10] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getConcreteMapping(), FEATURES[1]);
		LINKS[11] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getConcreteMapping(), FEATURES[1]);
		LINKS[12] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getRoleMapping(), FEATURES[0]);
		LINKS[13] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getRoleMapping(), FEATURES[0]);
		LINKS[14] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getAttributeMapping(), FEATURES[2]);
		LINKS[15] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getAttributeMapping(), FEATURES[2]);
		LINKS[16] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getCollaborationMapping(), FEATURES[3]);
		LINKS[17] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getCollaborationMapping(), FEATURES[3]);
		LINKS[18] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getCollaborationMapping(), FEATURES[3]);
		LINKS[19] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getConcreteMapping(), FEATURES[1]);
		LINKS[20] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getReferenceMetaClassPair(), FEATURES[4]);
		LINKS[21] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getReferenceMetaClassPair(), FEATURES[4]);
		LINKS[22] = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getCollaborationMapping(), FEATURES[3]);
	}
	
	public static void initializeLinks() {
		initializeLinks0();
	}
	
	public static void wire0() {
		TERMINALS[0].addFollower(TERMINALS[1], EMPTY_LINK_ARRAY);
		TERMINALS[1].addFollower(TERMINALS[2], EMPTY_LINK_ARRAY);
		TERMINALS[2].addFollower(TERMINALS[3], EMPTY_LINK_ARRAY);
		TERMINALS[2].addFollower(TERMINALS[4], new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature[] {new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getRoleMapping(), FEATURES[0]), });
		TERMINALS[2].addFollower(TERMINALS[5], new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature[] {new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getRoleMapping(), FEATURES[0]), });
		TERMINALS[3].addFollower(TERMINALS[6], EMPTY_LINK_ARRAY);
		TERMINALS[6].addFollower(TERMINALS[6], EMPTY_LINK_ARRAY);
		TERMINALS[6].addFollower(TERMINALS[4], new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature[] {new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getRoleMapping(), FEATURES[0]), });
		TERMINALS[6].addFollower(TERMINALS[5], new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature[] {new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getRoleMapping(), FEATURES[0]), });
		TERMINALS[4].addFollower(TERMINALS[7], EMPTY_LINK_ARRAY);
		TERMINALS[5].addFollower(TERMINALS[7], EMPTY_LINK_ARRAY);
		TERMINALS[7].addFollower(TERMINALS[8], EMPTY_LINK_ARRAY);
		TERMINALS[8].addFollower(TERMINALS[9], EMPTY_LINK_ARRAY);
		TERMINALS[9].addFollower(TERMINALS[10], new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature[] {new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getConcreteMapping(), FEATURES[1]), });
		TERMINALS[11].addFollower(TERMINALS[4], new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature[] {new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getRoleMapping(), FEATURES[0]), });
		TERMINALS[11].addFollower(TERMINALS[5], new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature[] {new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getRoleMapping(), FEATURES[0]), });
		TERMINALS[10].addFollower(TERMINALS[12], EMPTY_LINK_ARRAY);
		TERMINALS[12].addFollower(TERMINALS[13], EMPTY_LINK_ARRAY);
		TERMINALS[13].addFollower(TERMINALS[14], EMPTY_LINK_ARRAY);
		TERMINALS[13].addFollower(TERMINALS[15], EMPTY_LINK_ARRAY);
		TERMINALS[13].addFollower(TERMINALS[16], EMPTY_LINK_ARRAY);
		TERMINALS[14].addFollower(TERMINALS[17], new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature[] {new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getAttributeMapping(), FEATURES[2]), });
		TERMINALS[18].addFollower(TERMINALS[17], new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature[] {new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getAttributeMapping(), FEATURES[2]), });
		TERMINALS[19].addFollower(TERMINALS[15], EMPTY_LINK_ARRAY);
		TERMINALS[19].addFollower(TERMINALS[16], EMPTY_LINK_ARRAY);
		TERMINALS[15].addFollower(TERMINALS[20], new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature[] {new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getCollaborationMapping(), FEATURES[3]), });
		TERMINALS[21].addFollower(TERMINALS[16], EMPTY_LINK_ARRAY);
		TERMINALS[16].addFollower(TERMINALS[10], new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature[] {new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getConcreteMapping(), FEATURES[1]), });
		TERMINALS[16].addFollower(TERMINALS[11], EMPTY_LINK_ARRAY);
		TERMINALS[20].addFollower(TERMINALS[22], EMPTY_LINK_ARRAY);
		TERMINALS[22].addFollower(TERMINALS[23], new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature[] {new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getReferenceMetaClassPair(), FEATURES[4]), });
		TERMINALS[24].addFollower(TERMINALS[23], new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature[] {new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getReferenceMetaClassPair(), FEATURES[4]), });
		TERMINALS[25].addFollower(TERMINALS[20], new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature[] {new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getCollaborationMapping(), FEATURES[3]), });
		TERMINALS[25].addFollower(TERMINALS[21], EMPTY_LINK_ARRAY);
		TERMINALS[23].addFollower(TERMINALS[26], EMPTY_LINK_ARRAY);
		TERMINALS[23].addFollower(TERMINALS[24], EMPTY_LINK_ARRAY);
		TERMINALS[23].addFollower(TERMINALS[25], EMPTY_LINK_ARRAY);
		TERMINALS[26].addFollower(TERMINALS[27], EMPTY_LINK_ARRAY);
		TERMINALS[27].addFollower(TERMINALS[24], EMPTY_LINK_ARRAY);
		TERMINALS[27].addFollower(TERMINALS[25], EMPTY_LINK_ARRAY);
		TERMINALS[17].addFollower(TERMINALS[28], EMPTY_LINK_ARRAY);
		TERMINALS[28].addFollower(TERMINALS[29], EMPTY_LINK_ARRAY);
		TERMINALS[29].addFollower(TERMINALS[18], EMPTY_LINK_ARRAY);
		TERMINALS[29].addFollower(TERMINALS[19], EMPTY_LINK_ARRAY);
	}
	
	public static void wire() {
		wire0();
	}
	
	static {
		// initialize the arrays
		initializeTerminals();
		initializeFeatures();
		initializeLinks();
		// wire the terminals
		wire();
	}
}
