/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp;

/**
 * Abstract super class for all expected elements. Provides methods to add
 * followers.
 */
public abstract class RolemappingAbstractExpectedElement implements org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingExpectedElement {
	
	private org.eclipse.emf.ecore.EClass ruleMetaclass;
	
	private java.util.Set<org.emftext.language.refactoring.rolemapping.resource.rolemapping.util.RolemappingPair<org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingExpectedElement, org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature[]>> followers = new java.util.LinkedHashSet<org.emftext.language.refactoring.rolemapping.resource.rolemapping.util.RolemappingPair<org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingExpectedElement, org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature[]>>();
	
	public RolemappingAbstractExpectedElement(org.eclipse.emf.ecore.EClass ruleMetaclass) {
		super();
		this.ruleMetaclass = ruleMetaclass;
	}
	
	public org.eclipse.emf.ecore.EClass getRuleMetaclass() {
		return ruleMetaclass;
	}
	
	public void addFollower(org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingExpectedElement follower, org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature[] path) {
		followers.add(new org.emftext.language.refactoring.rolemapping.resource.rolemapping.util.RolemappingPair<org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingExpectedElement, org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature[]>(follower, path));
	}
	
	public java.util.Collection<org.emftext.language.refactoring.rolemapping.resource.rolemapping.util.RolemappingPair<org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingExpectedElement, org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingContainedFeature[]>> getFollowers() {
		return followers;
	}
	
}
