/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp;

public class RolemappingMetaInformation implements org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingMetaInformation {
	
	public String getSyntaxName() {
		return "rolemapping";
	}
	
	public String getURI() {
		return "http://www.emftext.org/language/rolemapping";
	}
	
	public org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingTextScanner createLexer() {
		return new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingAntlrScanner(new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingLexer());
	}
	
	public org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingTextParser createParser(java.io.InputStream inputStream, String encoding) {
		return new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingParser().createInstance(inputStream, encoding);
	}
	
	public org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingTextPrinter createPrinter(java.io.OutputStream outputStream, org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingTextResource resource) {
		return new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingPrinter2(outputStream, resource);
	}
	
	public org.eclipse.emf.ecore.EClass[] getClassesWithSyntax() {
		return new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingSyntaxCoverageInformationProvider().getClassesWithSyntax();
	}
	
	public org.eclipse.emf.ecore.EClass[] getStartSymbols() {
		return new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingSyntaxCoverageInformationProvider().getStartSymbols();
	}
	
	public org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingReferenceResolverSwitch getReferenceResolverSwitch() {
		return new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingReferenceResolverSwitch();
	}
	
	public org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingTokenResolverFactory getTokenResolverFactory() {
		return new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingTokenResolverFactory();
	}
	
	public String getPathToCSDefinition() {
		return "org.emftext.language.refactoring.rolemapping/metamodel/rolemapping.cs";
	}
	
	public String[] getTokenNames() {
		return org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingParser.tokenNames;
	}
	
	public org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingTokenStyle getDefaultTokenStyle(String tokenName) {
		return new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingTokenStyleInformationProvider().getDefaultTokenStyle(tokenName);
	}
	
	public java.util.Collection<org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingBracketPair> getBracketPairs() {
		return new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingBracketInformationProvider().getBracketPairs();
	}
	
	public org.eclipse.emf.ecore.EClass[] getFoldableClasses() {
		return new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingFoldingInformationProvider().getFoldableClasses();
	}
	
	public org.eclipse.emf.ecore.resource.Resource.Factory createResourceFactory() {
		return new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingResourceFactory();
	}
	
	public org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingNewFileContentProvider getNewFileContentProvider() {
		return new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingNewFileContentProvider();
	}
	
	public void registerResourceFactory() {
		org.eclipse.emf.ecore.resource.Resource.Factory.Registry.INSTANCE.getExtensionToFactoryMap().put(getSyntaxName(), new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingResourceFactory());
	}
	
	/**
	 * Returns the key of the option that can be used to register a preprocessor that
	 * is used as a pipe when loading resources. This key is language-specific. To
	 * register one preprocessor for multiple resource types, it must be registered
	 * individually using all keys.
	 */
	public String getInputStreamPreprocessorProviderOptionKey() {
		return getSyntaxName() + "_" + "INPUT_STREAM_PREPROCESSOR_PROVIDER";
	}
	
	/**
	 * Returns the key of the option that can be used to register a post-processors
	 * that are invoked after loading resources. This key is language-specific. To
	 * register one post-processor for multiple resource types, it must be registered
	 * individually using all keys.
	 */
	public String getResourcePostProcessorProviderOptionKey() {
		return getSyntaxName() + "_" + "RESOURCE_POSTPROCESSOR_PROVIDER";
	}
	
	public String getLaunchConfigurationType() {
		return "org.emftext.language.refactoring.rolemapping.resource.rolemapping.ui.launchConfigurationType";
	}
	
	public org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingNameProvider createNameProvider() {
		return new org.emftext.language.refactoring.rolemapping.resource.rolemapping.analysis.RolemappingDefaultNameProvider();
	}
	
	public String[] getSyntaxHighlightableTokenNames() {
		org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingAntlrTokenHelper tokenHelper = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingAntlrTokenHelper();
		java.util.List<String> highlightableTokens = new java.util.ArrayList<String>();
		String[] parserTokenNames = getTokenNames();
		for (int i = 0; i < parserTokenNames.length; i++) {
			// If ANTLR is used we need to normalize the token names
			if (!tokenHelper.canBeUsedForSyntaxHighlighting(i)) {
				continue;
			}
			String tokenName = tokenHelper.getTokenName(parserTokenNames, i);
			if (tokenName == null) {
				continue;
			}
			highlightableTokens.add(tokenName);
		}
		highlightableTokens.add(org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingTokenStyleInformationProvider.TASK_ITEM_TOKEN_NAME);
		return highlightableTokens.toArray(new String[highlightableTokens.size()]);
	}
	
}
