/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp;

public class RolemappingProblem implements org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingProblem {
	
	private String message;
	private org.emftext.language.refactoring.rolemapping.resource.rolemapping.RolemappingEProblemType type;
	private org.emftext.language.refactoring.rolemapping.resource.rolemapping.RolemappingEProblemSeverity severity;
	private java.util.Collection<org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingQuickFix> quickFixes;
	
	public RolemappingProblem(String message, org.emftext.language.refactoring.rolemapping.resource.rolemapping.RolemappingEProblemType type, org.emftext.language.refactoring.rolemapping.resource.rolemapping.RolemappingEProblemSeverity severity) {
		this(message, type, severity, java.util.Collections.<org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingQuickFix>emptySet());
	}
	
	public RolemappingProblem(String message, org.emftext.language.refactoring.rolemapping.resource.rolemapping.RolemappingEProblemType type, org.emftext.language.refactoring.rolemapping.resource.rolemapping.RolemappingEProblemSeverity severity, org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingQuickFix quickFix) {
		this(message, type, severity, java.util.Collections.singleton(quickFix));
	}
	
	public RolemappingProblem(String message, org.emftext.language.refactoring.rolemapping.resource.rolemapping.RolemappingEProblemType type, org.emftext.language.refactoring.rolemapping.resource.rolemapping.RolemappingEProblemSeverity severity, java.util.Collection<org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingQuickFix> quickFixes) {
		super();
		this.message = message;
		this.type = type;
		this.severity = severity;
		this.quickFixes = new java.util.LinkedHashSet<org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingQuickFix>();
		this.quickFixes.addAll(quickFixes);
	}
	
	public org.emftext.language.refactoring.rolemapping.resource.rolemapping.RolemappingEProblemType getType() {
		return type;
	}
	
	public org.emftext.language.refactoring.rolemapping.resource.rolemapping.RolemappingEProblemSeverity getSeverity() {
		return severity;
	}
	
	public String getMessage() {
		return message;
	}
	
	public java.util.Collection<org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingQuickFix> getQuickFixes() {
		return quickFixes;
	}
	
}
