/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp;

public class RolemappingReferenceResolverSwitch implements org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingReferenceResolverSwitch {
	
	/**
	 * This map stores a copy of the options the were set for loading the resource.
	 */
	private java.util.Map<Object, Object> options;
	
	protected org.emftext.language.refactoring.rolemapping.resource.rolemapping.analysis.RoleMappingModelTargetMetamodelReferenceResolver roleMappingModelTargetMetamodelReferenceResolver = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.analysis.RoleMappingModelTargetMetamodelReferenceResolver();
	protected org.emftext.language.refactoring.rolemapping.resource.rolemapping.analysis.RoleMappingModelImportsReferenceResolver roleMappingModelImportsReferenceResolver = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.analysis.RoleMappingModelImportsReferenceResolver();
	protected org.emftext.language.refactoring.rolemapping.resource.rolemapping.analysis.RoleMappingMappedRoleModelReferenceResolver roleMappingMappedRoleModelReferenceResolver = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.analysis.RoleMappingMappedRoleModelReferenceResolver();
	protected org.emftext.language.refactoring.rolemapping.resource.rolemapping.analysis.ConcreteMappingRoleReferenceResolver concreteMappingRoleReferenceResolver = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.analysis.ConcreteMappingRoleReferenceResolver();
	protected org.emftext.language.refactoring.rolemapping.resource.rolemapping.analysis.ConcreteMappingMetaclassReferenceResolver concreteMappingMetaclassReferenceResolver = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.analysis.ConcreteMappingMetaclassReferenceResolver();
	protected org.emftext.language.refactoring.rolemapping.resource.rolemapping.analysis.CollaborationMappingCollaborationReferenceResolver collaborationMappingCollaborationReferenceResolver = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.analysis.CollaborationMappingCollaborationReferenceResolver();
	protected org.emftext.language.refactoring.rolemapping.resource.rolemapping.analysis.ReferenceMetaClassPairReferenceReferenceResolver referenceMetaClassPairReferenceReferenceResolver = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.analysis.ReferenceMetaClassPairReferenceReferenceResolver();
	protected org.emftext.language.refactoring.rolemapping.resource.rolemapping.analysis.ReferenceMetaClassPairMetaClassReferenceResolver referenceMetaClassPairMetaClassReferenceResolver = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.analysis.ReferenceMetaClassPairMetaClassReferenceResolver();
	protected org.emftext.language.refactoring.rolemapping.resource.rolemapping.analysis.AttributeMappingRoleAttributeReferenceResolver attributeMappingRoleAttributeReferenceResolver = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.analysis.AttributeMappingRoleAttributeReferenceResolver();
	protected org.emftext.language.refactoring.rolemapping.resource.rolemapping.analysis.AttributeMappingClassAttributeReferenceResolver attributeMappingClassAttributeReferenceResolver = new org.emftext.language.refactoring.rolemapping.resource.rolemapping.analysis.AttributeMappingClassAttributeReferenceResolver();
	
	public org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingReferenceResolver<org.emftext.language.refactoring.rolemapping.RoleMappingModel, org.eclipse.emf.ecore.EPackage> getRoleMappingModelTargetMetamodelReferenceResolver() {
		return getResolverChain(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getRoleMappingModel_TargetMetamodel(), roleMappingModelTargetMetamodelReferenceResolver);
	}
	
	public org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingReferenceResolver<org.emftext.language.refactoring.rolemapping.RoleMappingModel, org.eclipse.emf.ecore.EPackage> getRoleMappingModelImportsReferenceResolver() {
		return getResolverChain(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getRoleMappingModel_Imports(), roleMappingModelImportsReferenceResolver);
	}
	
	public org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingReferenceResolver<org.emftext.language.refactoring.rolemapping.RoleMapping, org.emftext.language.refactoring.roles.RoleModel> getRoleMappingMappedRoleModelReferenceResolver() {
		return getResolverChain(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getRoleMapping_MappedRoleModel(), roleMappingMappedRoleModelReferenceResolver);
	}
	
	public org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingReferenceResolver<org.emftext.language.refactoring.rolemapping.ConcreteMapping, org.emftext.language.refactoring.roles.Role> getConcreteMappingRoleReferenceResolver() {
		return getResolverChain(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getConcreteMapping_Role(), concreteMappingRoleReferenceResolver);
	}
	
	public org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingReferenceResolver<org.emftext.language.refactoring.rolemapping.ConcreteMapping, org.eclipse.emf.ecore.EClass> getConcreteMappingMetaclassReferenceResolver() {
		return getResolverChain(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getConcreteMapping_Metaclass(), concreteMappingMetaclassReferenceResolver);
	}
	
	public org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingReferenceResolver<org.emftext.language.refactoring.rolemapping.CollaborationMapping, org.emftext.language.refactoring.roles.MultiplicityCollaboration> getCollaborationMappingCollaborationReferenceResolver() {
		return getResolverChain(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getCollaborationMapping_Collaboration(), collaborationMappingCollaborationReferenceResolver);
	}
	
	public org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingReferenceResolver<org.emftext.language.refactoring.rolemapping.ReferenceMetaClassPair, org.eclipse.emf.ecore.EReference> getReferenceMetaClassPairReferenceReferenceResolver() {
		return getResolverChain(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getReferenceMetaClassPair_Reference(), referenceMetaClassPairReferenceReferenceResolver);
	}
	
	public org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingReferenceResolver<org.emftext.language.refactoring.rolemapping.ReferenceMetaClassPair, org.eclipse.emf.ecore.EClass> getReferenceMetaClassPairMetaClassReferenceResolver() {
		return getResolverChain(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getReferenceMetaClassPair_MetaClass(), referenceMetaClassPairMetaClassReferenceResolver);
	}
	
	public org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingReferenceResolver<org.emftext.language.refactoring.rolemapping.AttributeMapping, org.emftext.language.refactoring.roles.RoleAttribute> getAttributeMappingRoleAttributeReferenceResolver() {
		return getResolverChain(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getAttributeMapping_RoleAttribute(), attributeMappingRoleAttributeReferenceResolver);
	}
	
	public org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingReferenceResolver<org.emftext.language.refactoring.rolemapping.AttributeMapping, org.eclipse.emf.ecore.EAttribute> getAttributeMappingClassAttributeReferenceResolver() {
		return getResolverChain(org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getAttributeMapping_ClassAttribute(), attributeMappingClassAttributeReferenceResolver);
	}
	
	public void setOptions(java.util.Map<?, ?> options) {
		if (options != null) {
			this.options = new java.util.LinkedHashMap<Object, Object>();
			this.options.putAll(options);
		}
		roleMappingModelTargetMetamodelReferenceResolver.setOptions(options);
		roleMappingModelImportsReferenceResolver.setOptions(options);
		roleMappingMappedRoleModelReferenceResolver.setOptions(options);
		concreteMappingRoleReferenceResolver.setOptions(options);
		concreteMappingMetaclassReferenceResolver.setOptions(options);
		collaborationMappingCollaborationReferenceResolver.setOptions(options);
		referenceMetaClassPairReferenceReferenceResolver.setOptions(options);
		referenceMetaClassPairMetaClassReferenceResolver.setOptions(options);
		attributeMappingRoleAttributeReferenceResolver.setOptions(options);
		attributeMappingClassAttributeReferenceResolver.setOptions(options);
	}
	
	public void resolveFuzzy(String identifier, org.eclipse.emf.ecore.EObject container, org.eclipse.emf.ecore.EReference reference, int position, org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingReferenceResolveResult<org.eclipse.emf.ecore.EObject> result) {
		if (container == null) {
			return;
		}
		if (org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getRoleMappingModel().isInstance(container)) {
			RolemappingFuzzyResolveResult<org.eclipse.emf.ecore.EPackage> frr = new RolemappingFuzzyResolveResult<org.eclipse.emf.ecore.EPackage>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("targetMetamodel")) {
				roleMappingModelTargetMetamodelReferenceResolver.resolve(identifier, (org.emftext.language.refactoring.rolemapping.RoleMappingModel) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
		if (org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getRoleMappingModel().isInstance(container)) {
			RolemappingFuzzyResolveResult<org.eclipse.emf.ecore.EPackage> frr = new RolemappingFuzzyResolveResult<org.eclipse.emf.ecore.EPackage>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("imports")) {
				roleMappingModelImportsReferenceResolver.resolve(identifier, (org.emftext.language.refactoring.rolemapping.RoleMappingModel) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
		if (org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getRoleMapping().isInstance(container)) {
			RolemappingFuzzyResolveResult<org.emftext.language.refactoring.roles.RoleModel> frr = new RolemappingFuzzyResolveResult<org.emftext.language.refactoring.roles.RoleModel>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("mappedRoleModel")) {
				roleMappingMappedRoleModelReferenceResolver.resolve(identifier, (org.emftext.language.refactoring.rolemapping.RoleMapping) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
		if (org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getConcreteMapping().isInstance(container)) {
			RolemappingFuzzyResolveResult<org.emftext.language.refactoring.roles.Role> frr = new RolemappingFuzzyResolveResult<org.emftext.language.refactoring.roles.Role>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("role")) {
				concreteMappingRoleReferenceResolver.resolve(identifier, (org.emftext.language.refactoring.rolemapping.ConcreteMapping) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
		if (org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getConcreteMapping().isInstance(container)) {
			RolemappingFuzzyResolveResult<org.eclipse.emf.ecore.EClass> frr = new RolemappingFuzzyResolveResult<org.eclipse.emf.ecore.EClass>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("metaclass")) {
				concreteMappingMetaclassReferenceResolver.resolve(identifier, (org.emftext.language.refactoring.rolemapping.ConcreteMapping) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
		if (org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getCollaborationMapping().isInstance(container)) {
			RolemappingFuzzyResolveResult<org.emftext.language.refactoring.roles.MultiplicityCollaboration> frr = new RolemappingFuzzyResolveResult<org.emftext.language.refactoring.roles.MultiplicityCollaboration>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("collaboration")) {
				collaborationMappingCollaborationReferenceResolver.resolve(identifier, (org.emftext.language.refactoring.rolemapping.CollaborationMapping) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
		if (org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getReferenceMetaClassPair().isInstance(container)) {
			RolemappingFuzzyResolveResult<org.eclipse.emf.ecore.EReference> frr = new RolemappingFuzzyResolveResult<org.eclipse.emf.ecore.EReference>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("reference")) {
				referenceMetaClassPairReferenceReferenceResolver.resolve(identifier, (org.emftext.language.refactoring.rolemapping.ReferenceMetaClassPair) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
		if (org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getReferenceMetaClassPair().isInstance(container)) {
			RolemappingFuzzyResolveResult<org.eclipse.emf.ecore.EClass> frr = new RolemappingFuzzyResolveResult<org.eclipse.emf.ecore.EClass>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("metaClass")) {
				referenceMetaClassPairMetaClassReferenceResolver.resolve(identifier, (org.emftext.language.refactoring.rolemapping.ReferenceMetaClassPair) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
		if (org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getAttributeMapping().isInstance(container)) {
			RolemappingFuzzyResolveResult<org.emftext.language.refactoring.roles.RoleAttribute> frr = new RolemappingFuzzyResolveResult<org.emftext.language.refactoring.roles.RoleAttribute>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("roleAttribute")) {
				attributeMappingRoleAttributeReferenceResolver.resolve(identifier, (org.emftext.language.refactoring.rolemapping.AttributeMapping) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
		if (org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getAttributeMapping().isInstance(container)) {
			RolemappingFuzzyResolveResult<org.eclipse.emf.ecore.EAttribute> frr = new RolemappingFuzzyResolveResult<org.eclipse.emf.ecore.EAttribute>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("classAttribute")) {
				attributeMappingClassAttributeReferenceResolver.resolve(identifier, (org.emftext.language.refactoring.rolemapping.AttributeMapping) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
	}
	
	public org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingReferenceResolver<? extends org.eclipse.emf.ecore.EObject, ? extends org.eclipse.emf.ecore.EObject> getResolver(org.eclipse.emf.ecore.EStructuralFeature reference) {
		if (reference == org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getRoleMappingModel_TargetMetamodel()) {
			return getResolverChain(reference, roleMappingModelTargetMetamodelReferenceResolver);
		}
		if (reference == org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getRoleMappingModel_Imports()) {
			return getResolverChain(reference, roleMappingModelImportsReferenceResolver);
		}
		if (reference == org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getRoleMapping_MappedRoleModel()) {
			return getResolverChain(reference, roleMappingMappedRoleModelReferenceResolver);
		}
		if (reference == org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getConcreteMapping_Role()) {
			return getResolverChain(reference, concreteMappingRoleReferenceResolver);
		}
		if (reference == org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getConcreteMapping_Metaclass()) {
			return getResolverChain(reference, concreteMappingMetaclassReferenceResolver);
		}
		if (reference == org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getCollaborationMapping_Collaboration()) {
			return getResolverChain(reference, collaborationMappingCollaborationReferenceResolver);
		}
		if (reference == org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getReferenceMetaClassPair_Reference()) {
			return getResolverChain(reference, referenceMetaClassPairReferenceReferenceResolver);
		}
		if (reference == org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getReferenceMetaClassPair_MetaClass()) {
			return getResolverChain(reference, referenceMetaClassPairMetaClassReferenceResolver);
		}
		if (reference == org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getAttributeMapping_RoleAttribute()) {
			return getResolverChain(reference, attributeMappingRoleAttributeReferenceResolver);
		}
		if (reference == org.emftext.language.refactoring.rolemapping.RolemappingPackage.eINSTANCE.getAttributeMapping_ClassAttribute()) {
			return getResolverChain(reference, attributeMappingClassAttributeReferenceResolver);
		}
		return null;
	}
	
	@SuppressWarnings({"rawtypes", "unchecked"})	
	public <ContainerType extends org.eclipse.emf.ecore.EObject, ReferenceType extends org.eclipse.emf.ecore.EObject> org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingReferenceResolver<ContainerType, ReferenceType> getResolverChain(org.eclipse.emf.ecore.EStructuralFeature reference, org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingReferenceResolver<ContainerType, ReferenceType> originalResolver) {
		if (options == null) {
			return originalResolver;
		}
		Object value = options.get(org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingOptions.ADDITIONAL_REFERENCE_RESOLVERS);
		if (value == null) {
			return originalResolver;
		}
		if (!(value instanceof java.util.Map)) {
			// send this to the error log
			new org.emftext.language.refactoring.rolemapping.resource.rolemapping.util.RolemappingRuntimeUtil().logWarning("Found value with invalid type for option " + org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingOptions.ADDITIONAL_REFERENCE_RESOLVERS + " (expected " + java.util.Map.class.getName() + ", but was " + value.getClass().getName() + ")", null);
			return originalResolver;
		}
		java.util.Map<?,?> resolverMap = (java.util.Map<?,?>) value;
		Object resolverValue = resolverMap.get(reference);
		if (resolverValue == null) {
			return originalResolver;
		}
		if (resolverValue instanceof org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingReferenceResolver) {
			org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingReferenceResolver replacingResolver = (org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingReferenceResolver) resolverValue;
			if (replacingResolver instanceof org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingDelegatingReferenceResolver) {
				// pass original resolver to the replacing one
				((org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingDelegatingReferenceResolver) replacingResolver).setDelegate(originalResolver);
			}
			return replacingResolver;
		} else if (resolverValue instanceof java.util.Collection) {
			java.util.Collection replacingResolvers = (java.util.Collection) resolverValue;
			org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingReferenceResolver replacingResolver = originalResolver;
			for (Object next : replacingResolvers) {
				if (next instanceof org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingReferenceCache) {
					org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingReferenceResolver nextResolver = (org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingReferenceResolver) next;
					if (nextResolver instanceof org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingDelegatingReferenceResolver) {
						// pass original resolver to the replacing one
						((org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingDelegatingReferenceResolver) nextResolver).setDelegate(replacingResolver);
					}
					replacingResolver = nextResolver;
				} else {
					// The collection contains a non-resolver. Send a warning to the error log.
					new org.emftext.language.refactoring.rolemapping.resource.rolemapping.util.RolemappingRuntimeUtil().logWarning("Found value with invalid type in value map for option " + org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingOptions.ADDITIONAL_REFERENCE_RESOLVERS + " (expected " + org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingDelegatingReferenceResolver.class.getName() + ", but was " + next.getClass().getName() + ")", null);
				}
			}
			return replacingResolver;
		} else {
			// The value for the option ADDITIONAL_REFERENCE_RESOLVERS has an unknown type.
			new org.emftext.language.refactoring.rolemapping.resource.rolemapping.util.RolemappingRuntimeUtil().logWarning("Found value with invalid type in value map for option " + org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingOptions.ADDITIONAL_REFERENCE_RESOLVERS + " (expected " + org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingDelegatingReferenceResolver.class.getName() + ", but was " + resolverValue.getClass().getName() + ")", null);
			return originalResolver;
		}
	}
	
}
