/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp;

public class RolemappingTokenStyleInformationProvider {
	
	public static String TASK_ITEM_TOKEN_NAME = "TASK_ITEM";
	
	public org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingTokenStyle getDefaultTokenStyle(String tokenName) {
		if ("ML_COMMENT".equals(tokenName)) {
			return new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingTokenStyle(new int[] {0x00, 0x80, 0x00}, null, false, true, false, false);
		}
		if ("SL_COMMENT".equals(tokenName)) {
			return new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingTokenStyle(new int[] {0x00, 0x80, 0x00}, null, false, true, false, false);
		}
		if ("ROLEMODELMAPPING".equals(tokenName)) {
			return new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingTokenStyle(new int[] {0x7F, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("FOR".equals(tokenName)) {
			return new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingTokenStyle(new int[] {0x7F, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("maps".equals(tokenName)) {
			return new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingTokenStyle(new int[] {0x7F, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("->".equals(tokenName)) {
			return new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingTokenStyle(new int[] {0xFF, 0xC4, 0x00}, null, true, false, false, false);
		}
		if ("IMPORTS".equals(tokenName)) {
			return new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("QUOTED_60_62".equals(tokenName)) {
			return new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingTokenStyle(new int[] {0x2A, 0x00, 0xFF}, null, false, false, false, false);
		}
		if ("QUOTED_34_34".equals(tokenName)) {
			return new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingTokenStyle(new int[] {0x2A, 0x00, 0xFF}, null, false, false, false, false);
		}
		if ("TASK_ITEM".equals(tokenName)) {
			return new org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingTokenStyle(new int[] {0x7F, 0x9F, 0xBF}, null, true, false, false, false);
		}
		return null;
	}
	
}
