/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.emftext.language.refactoring.rolemapping.resource.rolemapping.ui;

public class RolemappingUIMetaInformation extends org.emftext.language.refactoring.rolemapping.resource.rolemapping.mopp.RolemappingMetaInformation {
	
	public org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingHoverTextProvider getHoverTextProvider() {
		return new org.emftext.language.refactoring.rolemapping.resource.rolemapping.ui.RolemappingHoverTextProvider();
	}
	
	public org.emftext.language.refactoring.rolemapping.resource.rolemapping.ui.RolemappingImageProvider getImageProvider() {
		return org.emftext.language.refactoring.rolemapping.resource.rolemapping.ui.RolemappingImageProvider.INSTANCE;
	}
	
	public org.emftext.language.refactoring.rolemapping.resource.rolemapping.ui.RolemappingColorManager createColorManager() {
		return new org.emftext.language.refactoring.rolemapping.resource.rolemapping.ui.RolemappingColorManager();
	}
	
	/**
	 * @deprecated this method is only provided to preserve API compatibility. Use
	 * createTokenScanner(org.emftext.language.refactoring.rolemapping.resource.rolemap
	 * ping.IRolemappingTextResource,
	 * org.emftext.language.refactoring.rolemapping.resource.rolemapping.ui.Rolemapping
	 * ColorManager) instead.
	 */
	public org.emftext.language.refactoring.rolemapping.resource.rolemapping.ui.RolemappingTokenScanner createTokenScanner(org.emftext.language.refactoring.rolemapping.resource.rolemapping.ui.RolemappingColorManager colorManager) {
		return createTokenScanner(null, colorManager);
	}
	
	public org.emftext.language.refactoring.rolemapping.resource.rolemapping.ui.RolemappingTokenScanner createTokenScanner(org.emftext.language.refactoring.rolemapping.resource.rolemapping.IRolemappingTextResource resource, org.emftext.language.refactoring.rolemapping.resource.rolemapping.ui.RolemappingColorManager colorManager) {
		return new org.emftext.language.refactoring.rolemapping.resource.rolemapping.ui.RolemappingTokenScanner(resource, colorManager);
	}
	
	public org.emftext.language.refactoring.rolemapping.resource.rolemapping.ui.RolemappingCodeCompletionHelper createCodeCompletionHelper() {
		return new org.emftext.language.refactoring.rolemapping.resource.rolemapping.ui.RolemappingCodeCompletionHelper();
	}
	
}
