/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.emftext.language.refactoring.roles;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Collaboration</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.emftext.language.refactoring.roles.Collaboration#getSource <em>Source</em>}</li>
 *   <li>{@link org.emftext.language.refactoring.roles.Collaboration#getTarget <em>Target</em>}</li>
 *   <li>{@link org.emftext.language.refactoring.roles.Collaboration#getModifier <em>Modifier</em>}</li>
 *   <li>{@link org.emftext.language.refactoring.roles.Collaboration#getInterpretationContext <em>Interpretation Context</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.emftext.language.refactoring.roles.RolesPackage#getCollaboration()
 * @model abstract="true"
 * @generated
 */
public interface Collaboration extends RoleFeature
{
  /**
   * Returns the value of the '<em><b>Source</b></em>' reference.
   * It is bidirectional and its opposite is '{@link org.emftext.language.refactoring.roles.Role#getOutgoing <em>Outgoing</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Source</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Source</em>' reference.
   * @see #setSource(Role)
   * @see org.emftext.language.refactoring.roles.RolesPackage#getCollaboration_Source()
   * @see org.emftext.language.refactoring.roles.Role#getOutgoing
   * @model opposite="outgoing" required="true"
   * @generated
   */
  Role getSource();

  /**
   * Sets the value of the '{@link org.emftext.language.refactoring.roles.Collaboration#getSource <em>Source</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Source</em>' reference.
   * @see #getSource()
   * @generated
   */
  void setSource(Role value);

  /**
   * Returns the value of the '<em><b>Target</b></em>' reference.
   * It is bidirectional and its opposite is '{@link org.emftext.language.refactoring.roles.Role#getIncoming <em>Incoming</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Target</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Target</em>' reference.
   * @see #setTarget(Role)
   * @see org.emftext.language.refactoring.roles.RolesPackage#getCollaboration_Target()
   * @see org.emftext.language.refactoring.roles.Role#getIncoming
   * @model opposite="incoming" required="true"
   * @generated
   */
  Role getTarget();

  /**
   * Sets the value of the '{@link org.emftext.language.refactoring.roles.Collaboration#getTarget <em>Target</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Target</em>' reference.
   * @see #getTarget()
   * @generated
   */
  void setTarget(Role value);

  /**
   * Returns the value of the '<em><b>Modifier</b></em>' attribute list.
   * The list contents are of type {@link org.emftext.language.refactoring.roles.CollaborationModifier}.
   * The literals are from the enumeration {@link org.emftext.language.refactoring.roles.CollaborationModifier}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Modifier</em>' attribute list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Modifier</em>' attribute list.
   * @see org.emftext.language.refactoring.roles.CollaborationModifier
   * @see org.emftext.language.refactoring.roles.RolesPackage#getCollaboration_Modifier()
   * @model unique="false"
   * @generated
   */
  EList<CollaborationModifier> getModifier();

  /**
   * Returns the value of the '<em><b>Interpretation Context</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Interpretation Context</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Interpretation Context</em>' reference.
   * @see #setInterpretationContext(EObject)
   * @see org.emftext.language.refactoring.roles.RolesPackage#getCollaboration_InterpretationContext()
   * @model
   * @generated
   */
  EObject getInterpretationContext();

  /**
   * Sets the value of the '{@link org.emftext.language.refactoring.roles.Collaboration#getInterpretationContext <em>Interpretation Context</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Interpretation Context</em>' reference.
   * @see #getInterpretationContext()
   * @generated
   */
  void setInterpretationContext(EObject value);

} // Collaboration
