/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.emftext.language.refactoring.roles;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Role</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.emftext.language.refactoring.roles.Role#getOutgoing <em>Outgoing</em>}</li>
 *   <li>{@link org.emftext.language.refactoring.roles.Role#getIncoming <em>Incoming</em>}</li>
 *   <li>{@link org.emftext.language.refactoring.roles.Role#getModifier <em>Modifier</em>}</li>
 *   <li>{@link org.emftext.language.refactoring.roles.Role#getAttributes <em>Attributes</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.emftext.language.refactoring.roles.RolesPackage#getRole()
 * @model
 * @generated
 */
public interface Role extends NamedElement
{
  /**
   * Returns the value of the '<em><b>Outgoing</b></em>' reference list.
   * The list contents are of type {@link org.emftext.language.refactoring.roles.Collaboration}.
   * It is bidirectional and its opposite is '{@link org.emftext.language.refactoring.roles.Collaboration#getSource <em>Source</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Outgoing</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Outgoing</em>' reference list.
   * @see org.emftext.language.refactoring.roles.RolesPackage#getRole_Outgoing()
   * @see org.emftext.language.refactoring.roles.Collaboration#getSource
   * @model opposite="source"
   * @generated
   */
  EList<Collaboration> getOutgoing();

  /**
   * Returns the value of the '<em><b>Incoming</b></em>' reference list.
   * The list contents are of type {@link org.emftext.language.refactoring.roles.Collaboration}.
   * It is bidirectional and its opposite is '{@link org.emftext.language.refactoring.roles.Collaboration#getTarget <em>Target</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Incoming</em>' reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Incoming</em>' reference list.
   * @see org.emftext.language.refactoring.roles.RolesPackage#getRole_Incoming()
   * @see org.emftext.language.refactoring.roles.Collaboration#getTarget
   * @model opposite="target"
   * @generated
   */
  EList<Collaboration> getIncoming();

  /**
   * Returns the value of the '<em><b>Modifier</b></em>' attribute list.
   * The list contents are of type {@link org.emftext.language.refactoring.roles.RoleModifier}.
   * The literals are from the enumeration {@link org.emftext.language.refactoring.roles.RoleModifier}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Modifier</em>' attribute list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Modifier</em>' attribute list.
   * @see org.emftext.language.refactoring.roles.RoleModifier
   * @see org.emftext.language.refactoring.roles.RolesPackage#getRole_Modifier()
   * @model unique="false"
   * @generated
   */
  EList<RoleModifier> getModifier();

  /**
   * Returns the value of the '<em><b>Attributes</b></em>' containment reference list.
   * The list contents are of type {@link org.emftext.language.refactoring.roles.RoleAttribute}.
   * It is bidirectional and its opposite is '{@link org.emftext.language.refactoring.roles.RoleAttribute#getAttributeRole <em>Attribute Role</em>}'.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Attributes</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Attributes</em>' containment reference list.
   * @see org.emftext.language.refactoring.roles.RolesPackage#getRole_Attributes()
   * @see org.emftext.language.refactoring.roles.RoleAttribute#getAttributeRole
   * @model opposite="attributeRole" containment="true"
   * @generated
   */
  EList<RoleAttribute> getAttributes();

} // Role
