/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.emftext.language.refactoring.roles;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Role Model</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.emftext.language.refactoring.roles.RoleModel#getRoles <em>Roles</em>}</li>
 *   <li>{@link org.emftext.language.refactoring.roles.RoleModel#getCollaborations <em>Collaborations</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.emftext.language.refactoring.roles.RolesPackage#getRoleModel()
 * @model
 * @generated
 */
public interface RoleModel extends NamedElement
{
  /**
   * Returns the value of the '<em><b>Roles</b></em>' containment reference list.
   * The list contents are of type {@link org.emftext.language.refactoring.roles.Role}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Roles</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Roles</em>' containment reference list.
   * @see org.emftext.language.refactoring.roles.RolesPackage#getRoleModel_Roles()
   * @model containment="true" keys="name"
   * @generated
   */
  EList<Role> getRoles();

  /**
   * Returns the value of the '<em><b>Collaborations</b></em>' containment reference list.
   * The list contents are of type {@link org.emftext.language.refactoring.roles.Collaboration}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Collaborations</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Collaborations</em>' containment reference list.
   * @see org.emftext.language.refactoring.roles.RolesPackage#getRoleModel_Collaborations()
   * @model containment="true"
   * @generated
   */
  EList<Collaboration> getCollaborations();

} // RoleModel
