/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.emftext.language.refactoring.roles.resource.rolestext.grammar;

/**
 * This class provides the follow sets for all terminals of the grammar. These
 * sets are used during code completion.
 */
public class RolestextFollowSetProvider {
	
	public final static org.emftext.language.refactoring.roles.resource.rolestext.IRolestextExpectedElement TERMINALS[] = new org.emftext.language.refactoring.roles.resource.rolestext.IRolestextExpectedElement[49];
	
	public final static org.eclipse.emf.ecore.EStructuralFeature[] FEATURES = new org.eclipse.emf.ecore.EStructuralFeature[5];
	
	public final static org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] LINKS = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[119];
	
	public final static org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] EMPTY_LINK_ARRAY = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[0];
	
	public static void initializeTerminals0() {
		TERMINALS[0] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedStructuralFeature(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_0_0_0_0_0_0_0);
		TERMINALS[1] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedCsString(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_0_0_0_1);
		TERMINALS[2] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedStructuralFeature(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_0_0_0_3);
		TERMINALS[3] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedCsString(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_0_0_0_4);
		TERMINALS[4] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedStructuralFeature(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_1_0_0_0_0_0_0);
		TERMINALS[5] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedStructuralFeature(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_1_0_0_1_0_0_0);
		TERMINALS[6] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedCsString(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_1_0_0_3);
		TERMINALS[7] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedStructuralFeature(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_3_0_0_0_0_0_0);
		TERMINALS[8] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedCsString(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_3_0_0_0_0_0_2);
		TERMINALS[9] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedStructuralFeature(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_3_0_0_2);
		TERMINALS[10] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedStructuralFeature(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_4_0_0_0_0_0_0);
		TERMINALS[11] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedCsString(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_4_0_0_0_0_0_2);
		TERMINALS[12] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedStructuralFeature(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_4_0_0_2);
		TERMINALS[13] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedStructuralFeature(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_5_0_0_0_0_0_0);
		TERMINALS[14] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedCsString(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_5_0_0_0_0_0_2);
		TERMINALS[15] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedStructuralFeature(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_5_0_0_2);
		TERMINALS[16] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedStructuralFeature(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_6_0_0_0_0_0_0);
		TERMINALS[17] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedCsString(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_6_0_0_0_0_0_2);
		TERMINALS[18] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedStructuralFeature(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_6_0_0_2);
		TERMINALS[19] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedCsString(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_0_0_0_11);
		TERMINALS[20] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedStructuralFeature(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_1_0_0_5);
		TERMINALS[21] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedCsString(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_1_0_0_6_0_0_0);
		TERMINALS[22] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedCsString(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_1_0_0_7);
		TERMINALS[23] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedStructuralFeature(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_2_0_0_0_0_0_0);
		TERMINALS[24] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedStructuralFeature(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_2_0_0_1);
		TERMINALS[25] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedStructuralFeature(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_2_0_0_2);
		TERMINALS[26] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedCsString(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_1_0_0_6_0_0_2_0_0_0);
		TERMINALS[27] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedCsString(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_1_0_0_6_0_0_3);
		TERMINALS[28] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedCsString(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_3_0_0_4);
		TERMINALS[29] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedStructuralFeature(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_3_0_0_6);
		TERMINALS[30] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedCsString(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_3_0_0_7);
		TERMINALS[31] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedCsString(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_4_0_0_4);
		TERMINALS[32] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedStructuralFeature(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_4_0_0_6);
		TERMINALS[33] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedCsString(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_4_0_0_7);
		TERMINALS[34] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedStructuralFeature(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_5_0_0_4);
		TERMINALS[35] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedCsString(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_7_0_0_0);
		TERMINALS[36] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedCsString(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_5_0_0_8);
		TERMINALS[37] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedStructuralFeature(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_5_0_0_10);
		TERMINALS[38] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedStructuralFeature(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_5_0_0_12);
		TERMINALS[39] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedCsString(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_5_0_0_15);
		TERMINALS[40] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedStructuralFeature(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_6_0_0_4);
		TERMINALS[41] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedCsString(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_6_0_0_8);
		TERMINALS[42] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedStructuralFeature(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_6_0_0_10);
		TERMINALS[43] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedStructuralFeature(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_6_0_0_12);
		TERMINALS[44] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedCsString(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_6_0_0_15);
		TERMINALS[45] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedStructuralFeature(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_7_0_0_1);
		TERMINALS[46] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedCsString(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_7_0_0_2);
		TERMINALS[47] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedStructuralFeature(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_7_0_0_3);
		TERMINALS[48] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextExpectedCsString(org.emftext.language.refactoring.roles.resource.rolestext.grammar.RolestextGrammarInformationProvider.ROLESTEXT_7_0_0_4);
	}
	
	public static void initializeTerminals() {
		initializeTerminals0();
	}
	
	public static void initializeFeatures0() {
		FEATURES[0] = org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleModel().getEStructuralFeature(org.emftext.language.refactoring.roles.RolesPackage.ROLE_MODEL__ROLES);
		FEATURES[1] = org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleModel().getEStructuralFeature(org.emftext.language.refactoring.roles.RolesPackage.ROLE_MODEL__COLLABORATIONS);
		FEATURES[2] = org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRole().getEStructuralFeature(org.emftext.language.refactoring.roles.RolesPackage.ROLE__ATTRIBUTES);
		FEATURES[3] = org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getMultiplicityCollaboration().getEStructuralFeature(org.emftext.language.refactoring.roles.RolesPackage.MULTIPLICITY_COLLABORATION__SOURCE_MULTIPLICITY);
		FEATURES[4] = org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getMultiplicityCollaboration().getEStructuralFeature(org.emftext.language.refactoring.roles.RolesPackage.MULTIPLICITY_COLLABORATION__TARGET_MULTIPLICITY);
	}
	
	public static void initializeFeatures() {
		initializeFeatures0();
	}
	
	public static void initializeLinks0() {
		LINKS[0] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRole(), FEATURES[0]);
		LINKS[1] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRole(), FEATURES[0]);
		LINKS[2] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRole(), FEATURES[0]);
		LINKS[3] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]);
		LINKS[4] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]);
		LINKS[5] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]);
		LINKS[6] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]);
		LINKS[7] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]);
		LINKS[8] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]);
		LINKS[9] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]);
		LINKS[10] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]);
		LINKS[11] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]);
		LINKS[12] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]);
		LINKS[13] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]);
		LINKS[14] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]);
		LINKS[15] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRole(), FEATURES[0]);
		LINKS[16] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRole(), FEATURES[0]);
		LINKS[17] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRole(), FEATURES[0]);
		LINKS[18] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]);
		LINKS[19] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]);
		LINKS[20] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]);
		LINKS[21] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]);
		LINKS[22] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]);
		LINKS[23] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]);
		LINKS[24] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]);
		LINKS[25] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]);
		LINKS[26] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]);
		LINKS[27] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]);
		LINKS[28] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]);
		LINKS[29] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]);
		LINKS[30] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]);
		LINKS[31] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]);
		LINKS[32] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]);
		LINKS[33] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]);
		LINKS[34] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]);
		LINKS[35] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]);
		LINKS[36] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]);
		LINKS[37] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]);
		LINKS[38] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]);
		LINKS[39] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]);
		LINKS[40] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]);
		LINKS[41] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]);
		LINKS[42] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAttribute(), FEATURES[2]);
		LINKS[43] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAttribute(), FEATURES[2]);
		LINKS[44] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAttribute(), FEATURES[2]);
		LINKS[45] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAttribute(), FEATURES[2]);
		LINKS[46] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAttribute(), FEATURES[2]);
		LINKS[47] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAttribute(), FEATURES[2]);
		LINKS[48] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRole(), FEATURES[0]);
		LINKS[49] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRole(), FEATURES[0]);
		LINKS[50] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRole(), FEATURES[0]);
		LINKS[51] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]);
		LINKS[52] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]);
		LINKS[53] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]);
		LINKS[54] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]);
		LINKS[55] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]);
		LINKS[56] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]);
		LINKS[57] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]);
		LINKS[58] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]);
		LINKS[59] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]);
		LINKS[60] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]);
		LINKS[61] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]);
		LINKS[62] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]);
		LINKS[63] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]);
		LINKS[64] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]);
		LINKS[65] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]);
		LINKS[66] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]);
		LINKS[67] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]);
		LINKS[68] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]);
		LINKS[69] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]);
		LINKS[70] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]);
		LINKS[71] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]);
		LINKS[72] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]);
		LINKS[73] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]);
		LINKS[74] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]);
		LINKS[75] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]);
		LINKS[76] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]);
		LINKS[77] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]);
		LINKS[78] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]);
		LINKS[79] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]);
		LINKS[80] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]);
		LINKS[81] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]);
		LINKS[82] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]);
		LINKS[83] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]);
		LINKS[84] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]);
		LINKS[85] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]);
		LINKS[86] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]);
		LINKS[87] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getMultiplicity(), FEATURES[3]);
		LINKS[88] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getMultiplicity(), FEATURES[3]);
		LINKS[89] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getMultiplicity(), FEATURES[4]);
		LINKS[90] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getMultiplicity(), FEATURES[4]);
		LINKS[91] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]);
		LINKS[92] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]);
		LINKS[93] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]);
		LINKS[94] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]);
		LINKS[95] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]);
		LINKS[96] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]);
		LINKS[97] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]);
		LINKS[98] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]);
		LINKS[99] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]);
		LINKS[100] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]);
		LINKS[101] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]);
		LINKS[102] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]);
		LINKS[103] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getMultiplicity(), FEATURES[3]);
		LINKS[104] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getMultiplicity(), FEATURES[3]);
		LINKS[105] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getMultiplicity(), FEATURES[4]);
		LINKS[106] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getMultiplicity(), FEATURES[4]);
		LINKS[107] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]);
		LINKS[108] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]);
		LINKS[109] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]);
		LINKS[110] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]);
		LINKS[111] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]);
		LINKS[112] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]);
		LINKS[113] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]);
		LINKS[114] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]);
		LINKS[115] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]);
		LINKS[116] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]);
		LINKS[117] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]);
		LINKS[118] = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]);
	}
	
	public static void initializeLinks() {
		initializeLinks0();
	}
	
	public static void wire0() {
		TERMINALS[0].addFollower(TERMINALS[1], EMPTY_LINK_ARRAY);
		TERMINALS[1].addFollower(TERMINALS[2], EMPTY_LINK_ARRAY);
		TERMINALS[2].addFollower(TERMINALS[3], EMPTY_LINK_ARRAY);
		TERMINALS[3].addFollower(TERMINALS[4], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRole(), FEATURES[0]), });
		TERMINALS[3].addFollower(TERMINALS[5], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRole(), FEATURES[0]), });
		TERMINALS[3].addFollower(TERMINALS[6], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRole(), FEATURES[0]), });
		TERMINALS[3].addFollower(TERMINALS[7], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]), });
		TERMINALS[3].addFollower(TERMINALS[8], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]), });
		TERMINALS[3].addFollower(TERMINALS[9], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]), });
		TERMINALS[3].addFollower(TERMINALS[10], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]), });
		TERMINALS[3].addFollower(TERMINALS[11], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]), });
		TERMINALS[3].addFollower(TERMINALS[12], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]), });
		TERMINALS[3].addFollower(TERMINALS[13], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]), });
		TERMINALS[3].addFollower(TERMINALS[14], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]), });
		TERMINALS[3].addFollower(TERMINALS[15], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]), });
		TERMINALS[3].addFollower(TERMINALS[16], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]), });
		TERMINALS[3].addFollower(TERMINALS[17], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]), });
		TERMINALS[3].addFollower(TERMINALS[18], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]), });
		TERMINALS[3].addFollower(TERMINALS[19], EMPTY_LINK_ARRAY);
		TERMINALS[4].addFollower(TERMINALS[5], EMPTY_LINK_ARRAY);
		TERMINALS[4].addFollower(TERMINALS[6], EMPTY_LINK_ARRAY);
		TERMINALS[5].addFollower(TERMINALS[5], EMPTY_LINK_ARRAY);
		TERMINALS[5].addFollower(TERMINALS[6], EMPTY_LINK_ARRAY);
		TERMINALS[6].addFollower(TERMINALS[20], EMPTY_LINK_ARRAY);
		TERMINALS[20].addFollower(TERMINALS[21], EMPTY_LINK_ARRAY);
		TERMINALS[20].addFollower(TERMINALS[22], EMPTY_LINK_ARRAY);
		TERMINALS[21].addFollower(TERMINALS[23], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAttribute(), FEATURES[2]), });
		TERMINALS[21].addFollower(TERMINALS[24], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAttribute(), FEATURES[2]), });
		TERMINALS[21].addFollower(TERMINALS[25], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAttribute(), FEATURES[2]), });
		TERMINALS[26].addFollower(TERMINALS[23], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAttribute(), FEATURES[2]), });
		TERMINALS[26].addFollower(TERMINALS[24], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAttribute(), FEATURES[2]), });
		TERMINALS[26].addFollower(TERMINALS[25], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAttribute(), FEATURES[2]), });
		TERMINALS[27].addFollower(TERMINALS[22], EMPTY_LINK_ARRAY);
		TERMINALS[22].addFollower(TERMINALS[4], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRole(), FEATURES[0]), });
		TERMINALS[22].addFollower(TERMINALS[5], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRole(), FEATURES[0]), });
		TERMINALS[22].addFollower(TERMINALS[6], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRole(), FEATURES[0]), });
		TERMINALS[22].addFollower(TERMINALS[7], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]), });
		TERMINALS[22].addFollower(TERMINALS[8], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]), });
		TERMINALS[22].addFollower(TERMINALS[9], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]), });
		TERMINALS[22].addFollower(TERMINALS[10], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]), });
		TERMINALS[22].addFollower(TERMINALS[11], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]), });
		TERMINALS[22].addFollower(TERMINALS[12], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]), });
		TERMINALS[22].addFollower(TERMINALS[13], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]), });
		TERMINALS[22].addFollower(TERMINALS[14], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]), });
		TERMINALS[22].addFollower(TERMINALS[15], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]), });
		TERMINALS[22].addFollower(TERMINALS[16], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]), });
		TERMINALS[22].addFollower(TERMINALS[17], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]), });
		TERMINALS[22].addFollower(TERMINALS[18], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]), });
		TERMINALS[22].addFollower(TERMINALS[19], EMPTY_LINK_ARRAY);
		TERMINALS[23].addFollower(TERMINALS[24], EMPTY_LINK_ARRAY);
		TERMINALS[23].addFollower(TERMINALS[25], EMPTY_LINK_ARRAY);
		TERMINALS[24].addFollower(TERMINALS[24], EMPTY_LINK_ARRAY);
		TERMINALS[24].addFollower(TERMINALS[25], EMPTY_LINK_ARRAY);
		TERMINALS[25].addFollower(TERMINALS[26], EMPTY_LINK_ARRAY);
		TERMINALS[25].addFollower(TERMINALS[27], EMPTY_LINK_ARRAY);
		TERMINALS[7].addFollower(TERMINALS[7], EMPTY_LINK_ARRAY);
		TERMINALS[7].addFollower(TERMINALS[8], EMPTY_LINK_ARRAY);
		TERMINALS[8].addFollower(TERMINALS[9], EMPTY_LINK_ARRAY);
		TERMINALS[9].addFollower(TERMINALS[28], EMPTY_LINK_ARRAY);
		TERMINALS[28].addFollower(TERMINALS[29], EMPTY_LINK_ARRAY);
		TERMINALS[29].addFollower(TERMINALS[30], EMPTY_LINK_ARRAY);
		TERMINALS[30].addFollower(TERMINALS[7], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]), });
		TERMINALS[30].addFollower(TERMINALS[8], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]), });
		TERMINALS[30].addFollower(TERMINALS[9], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]), });
		TERMINALS[30].addFollower(TERMINALS[10], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]), });
		TERMINALS[30].addFollower(TERMINALS[11], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]), });
		TERMINALS[30].addFollower(TERMINALS[12], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]), });
		TERMINALS[30].addFollower(TERMINALS[13], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]), });
		TERMINALS[30].addFollower(TERMINALS[14], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]), });
		TERMINALS[30].addFollower(TERMINALS[15], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]), });
		TERMINALS[30].addFollower(TERMINALS[16], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]), });
		TERMINALS[30].addFollower(TERMINALS[17], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]), });
		TERMINALS[30].addFollower(TERMINALS[18], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]), });
		TERMINALS[30].addFollower(TERMINALS[19], EMPTY_LINK_ARRAY);
		TERMINALS[10].addFollower(TERMINALS[10], EMPTY_LINK_ARRAY);
		TERMINALS[10].addFollower(TERMINALS[11], EMPTY_LINK_ARRAY);
		TERMINALS[11].addFollower(TERMINALS[12], EMPTY_LINK_ARRAY);
		TERMINALS[12].addFollower(TERMINALS[31], EMPTY_LINK_ARRAY);
		TERMINALS[31].addFollower(TERMINALS[32], EMPTY_LINK_ARRAY);
		TERMINALS[32].addFollower(TERMINALS[33], EMPTY_LINK_ARRAY);
		TERMINALS[33].addFollower(TERMINALS[7], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]), });
		TERMINALS[33].addFollower(TERMINALS[8], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]), });
		TERMINALS[33].addFollower(TERMINALS[9], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]), });
		TERMINALS[33].addFollower(TERMINALS[10], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]), });
		TERMINALS[33].addFollower(TERMINALS[11], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]), });
		TERMINALS[33].addFollower(TERMINALS[12], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]), });
		TERMINALS[33].addFollower(TERMINALS[13], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]), });
		TERMINALS[33].addFollower(TERMINALS[14], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]), });
		TERMINALS[33].addFollower(TERMINALS[15], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]), });
		TERMINALS[33].addFollower(TERMINALS[16], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]), });
		TERMINALS[33].addFollower(TERMINALS[17], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]), });
		TERMINALS[33].addFollower(TERMINALS[18], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]), });
		TERMINALS[33].addFollower(TERMINALS[19], EMPTY_LINK_ARRAY);
		TERMINALS[13].addFollower(TERMINALS[13], EMPTY_LINK_ARRAY);
		TERMINALS[13].addFollower(TERMINALS[14], EMPTY_LINK_ARRAY);
		TERMINALS[14].addFollower(TERMINALS[15], EMPTY_LINK_ARRAY);
		TERMINALS[15].addFollower(TERMINALS[34], EMPTY_LINK_ARRAY);
		TERMINALS[15].addFollower(TERMINALS[35], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getMultiplicity(), FEATURES[3]), });
		TERMINALS[34].addFollower(TERMINALS[35], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getMultiplicity(), FEATURES[3]), });
		TERMINALS[36].addFollower(TERMINALS[37], EMPTY_LINK_ARRAY);
		TERMINALS[37].addFollower(TERMINALS[38], EMPTY_LINK_ARRAY);
		TERMINALS[37].addFollower(TERMINALS[35], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getMultiplicity(), FEATURES[4]), });
		TERMINALS[38].addFollower(TERMINALS[35], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getMultiplicity(), FEATURES[4]), });
		TERMINALS[39].addFollower(TERMINALS[7], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]), });
		TERMINALS[39].addFollower(TERMINALS[8], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]), });
		TERMINALS[39].addFollower(TERMINALS[9], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]), });
		TERMINALS[39].addFollower(TERMINALS[10], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]), });
		TERMINALS[39].addFollower(TERMINALS[11], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]), });
		TERMINALS[39].addFollower(TERMINALS[12], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]), });
		TERMINALS[39].addFollower(TERMINALS[13], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]), });
		TERMINALS[39].addFollower(TERMINALS[14], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]), });
		TERMINALS[39].addFollower(TERMINALS[15], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]), });
		TERMINALS[39].addFollower(TERMINALS[16], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]), });
		TERMINALS[39].addFollower(TERMINALS[17], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]), });
		TERMINALS[39].addFollower(TERMINALS[18], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]), });
		TERMINALS[39].addFollower(TERMINALS[19], EMPTY_LINK_ARRAY);
		TERMINALS[16].addFollower(TERMINALS[16], EMPTY_LINK_ARRAY);
		TERMINALS[16].addFollower(TERMINALS[17], EMPTY_LINK_ARRAY);
		TERMINALS[17].addFollower(TERMINALS[18], EMPTY_LINK_ARRAY);
		TERMINALS[18].addFollower(TERMINALS[40], EMPTY_LINK_ARRAY);
		TERMINALS[18].addFollower(TERMINALS[35], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getMultiplicity(), FEATURES[3]), });
		TERMINALS[40].addFollower(TERMINALS[35], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getMultiplicity(), FEATURES[3]), });
		TERMINALS[41].addFollower(TERMINALS[42], EMPTY_LINK_ARRAY);
		TERMINALS[42].addFollower(TERMINALS[43], EMPTY_LINK_ARRAY);
		TERMINALS[42].addFollower(TERMINALS[35], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getMultiplicity(), FEATURES[4]), });
		TERMINALS[43].addFollower(TERMINALS[35], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getMultiplicity(), FEATURES[4]), });
		TERMINALS[44].addFollower(TERMINALS[7], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]), });
		TERMINALS[44].addFollower(TERMINALS[8], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]), });
		TERMINALS[44].addFollower(TERMINALS[9], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleProhibition(), FEATURES[1]), });
		TERMINALS[44].addFollower(TERMINALS[10], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]), });
		TERMINALS[44].addFollower(TERMINALS[11], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]), });
		TERMINALS[44].addFollower(TERMINALS[12], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleImplication(), FEATURES[1]), });
		TERMINALS[44].addFollower(TERMINALS[13], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]), });
		TERMINALS[44].addFollower(TERMINALS[14], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]), });
		TERMINALS[44].addFollower(TERMINALS[15], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleAssociation(), FEATURES[1]), });
		TERMINALS[44].addFollower(TERMINALS[16], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]), });
		TERMINALS[44].addFollower(TERMINALS[17], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]), });
		TERMINALS[44].addFollower(TERMINALS[18], new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature[] {new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextContainedFeature(org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleComposition(), FEATURES[1]), });
		TERMINALS[44].addFollower(TERMINALS[19], EMPTY_LINK_ARRAY);
		TERMINALS[35].addFollower(TERMINALS[45], EMPTY_LINK_ARRAY);
		TERMINALS[45].addFollower(TERMINALS[46], EMPTY_LINK_ARRAY);
		TERMINALS[46].addFollower(TERMINALS[47], EMPTY_LINK_ARRAY);
		TERMINALS[47].addFollower(TERMINALS[48], EMPTY_LINK_ARRAY);
		TERMINALS[48].addFollower(TERMINALS[36], EMPTY_LINK_ARRAY);
		TERMINALS[48].addFollower(TERMINALS[41], EMPTY_LINK_ARRAY);
	}
	
	public static void wire() {
		wire0();
	}
	
	static {
		// initialize the arrays
		initializeTerminals();
		initializeFeatures();
		initializeLinks();
		// wire the terminals
		wire();
	}
}
