/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.emftext.language.refactoring.roles.resource.rolestext.mopp;

public class RolestextMetaInformation implements org.emftext.language.refactoring.roles.resource.rolestext.IRolestextMetaInformation {
	
	public String getSyntaxName() {
		return "rolestext";
	}
	
	public String getURI() {
		return "http://www.emftext.org/language/roles";
	}
	
	public org.emftext.language.refactoring.roles.resource.rolestext.IRolestextTextScanner createLexer() {
		return new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextAntlrScanner(new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextLexer());
	}
	
	public org.emftext.language.refactoring.roles.resource.rolestext.IRolestextTextParser createParser(java.io.InputStream inputStream, String encoding) {
		return new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextParser().createInstance(inputStream, encoding);
	}
	
	public org.emftext.language.refactoring.roles.resource.rolestext.IRolestextTextPrinter createPrinter(java.io.OutputStream outputStream, org.emftext.language.refactoring.roles.resource.rolestext.IRolestextTextResource resource) {
		return new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextPrinter2(outputStream, resource);
	}
	
	public org.eclipse.emf.ecore.EClass[] getClassesWithSyntax() {
		return new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextSyntaxCoverageInformationProvider().getClassesWithSyntax();
	}
	
	public org.eclipse.emf.ecore.EClass[] getStartSymbols() {
		return new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextSyntaxCoverageInformationProvider().getStartSymbols();
	}
	
	public org.emftext.language.refactoring.roles.resource.rolestext.IRolestextReferenceResolverSwitch getReferenceResolverSwitch() {
		return new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextReferenceResolverSwitch();
	}
	
	public org.emftext.language.refactoring.roles.resource.rolestext.IRolestextTokenResolverFactory getTokenResolverFactory() {
		return new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextTokenResolverFactory();
	}
	
	public String getPathToCSDefinition() {
		return "org.emftext.language.refactoring.roles/metamodel/roles.cs";
	}
	
	public String[] getTokenNames() {
		return org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextParser.tokenNames;
	}
	
	public org.emftext.language.refactoring.roles.resource.rolestext.IRolestextTokenStyle getDefaultTokenStyle(String tokenName) {
		return new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextTokenStyleInformationProvider().getDefaultTokenStyle(tokenName);
	}
	
	public java.util.Collection<org.emftext.language.refactoring.roles.resource.rolestext.IRolestextBracketPair> getBracketPairs() {
		return new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextBracketInformationProvider().getBracketPairs();
	}
	
	public org.eclipse.emf.ecore.EClass[] getFoldableClasses() {
		return new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextFoldingInformationProvider().getFoldableClasses();
	}
	
	public org.eclipse.emf.ecore.resource.Resource.Factory createResourceFactory() {
		return new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextResourceFactory();
	}
	
	public org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextNewFileContentProvider getNewFileContentProvider() {
		return new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextNewFileContentProvider();
	}
	
	public void registerResourceFactory() {
		org.eclipse.emf.ecore.resource.Resource.Factory.Registry.INSTANCE.getExtensionToFactoryMap().put(getSyntaxName(), new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextResourceFactory());
	}
	
	/**
	 * Returns the key of the option that can be used to register a preprocessor that
	 * is used as a pipe when loading resources. This key is language-specific. To
	 * register one preprocessor for multiple resource types, it must be registered
	 * individually using all keys.
	 */
	public String getInputStreamPreprocessorProviderOptionKey() {
		return getSyntaxName() + "_" + "INPUT_STREAM_PREPROCESSOR_PROVIDER";
	}
	
	/**
	 * Returns the key of the option that can be used to register a post-processors
	 * that are invoked after loading resources. This key is language-specific. To
	 * register one post-processor for multiple resource types, it must be registered
	 * individually using all keys.
	 */
	public String getResourcePostProcessorProviderOptionKey() {
		return getSyntaxName() + "_" + "RESOURCE_POSTPROCESSOR_PROVIDER";
	}
	
	public String getLaunchConfigurationType() {
		return "org.emftext.language.refactoring.roles.resource.rolestext.ui.launchConfigurationType";
	}
	
	public org.emftext.language.refactoring.roles.resource.rolestext.IRolestextNameProvider createNameProvider() {
		return new org.emftext.language.refactoring.roles.resource.rolestext.analysis.RolestextDefaultNameProvider();
	}
	
	public String[] getSyntaxHighlightableTokenNames() {
		org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextAntlrTokenHelper tokenHelper = new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextAntlrTokenHelper();
		java.util.List<String> highlightableTokens = new java.util.ArrayList<String>();
		String[] parserTokenNames = getTokenNames();
		for (int i = 0; i < parserTokenNames.length; i++) {
			// If ANTLR is used we need to normalize the token names
			if (!tokenHelper.canBeUsedForSyntaxHighlighting(i)) {
				continue;
			}
			String tokenName = tokenHelper.getTokenName(parserTokenNames, i);
			if (tokenName == null) {
				continue;
			}
			highlightableTokens.add(tokenName);
		}
		highlightableTokens.add(org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextTokenStyleInformationProvider.TASK_ITEM_TOKEN_NAME);
		return highlightableTokens.toArray(new String[highlightableTokens.size()]);
	}
	
}
