/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.emftext.language.refactoring.roles.resource.rolestext.mopp;

public class RolestextNewFileContentProvider {
	
	public org.emftext.language.refactoring.roles.resource.rolestext.IRolestextMetaInformation getMetaInformation() {
		return new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextMetaInformation();
	}
	
	public String getNewFileContent(String newFileName) {
		return getExampleContent(new org.eclipse.emf.ecore.EClass[] {
			org.emftext.language.refactoring.roles.RolesPackage.eINSTANCE.getRoleModel(),
		}, getMetaInformation().getClassesWithSyntax(), newFileName);
	}
	
	protected String getExampleContent(org.eclipse.emf.ecore.EClass[] startClasses, org.eclipse.emf.ecore.EClass[] allClassesWithSyntax, String newFileName) {
		String content = "/**\nThis role model is a very simple one but with extensive impacts because it is one of the more often\nused refactorings in practice. 'Rename Method' has to be used if one wants to rename the methods name\nand update all references to this method that they stay consistent. Originally <a href=\"http://www.refactoring.com/catalog/renameMethod.html\">Rename Method</a> \ncomes from the Fowler book.\n*/\nRoleModel RenameXample { \n\t\n\t/**\n\tMap this role on a metaclass that owns an attribute which stands for the name and is intended to be renamed.\n\t*/\n\tsuper input ROLE Nameable (\n\t\t/**\n\t\tMap this attribute to a String attribute of the owning metaclass which represents the name of it.\n\t\t*/\n\t\tname\n\t);\t\n} ".replace("\n", System.getProperty("line.separator"));
		return content;
	}
	
	protected String getExampleContent(org.eclipse.emf.ecore.EClass eClass, org.eclipse.emf.ecore.EClass[] allClassesWithSyntax, String newFileName) {
		// create a minimal model
		org.eclipse.emf.ecore.EObject root = new org.emftext.language.refactoring.roles.resource.rolestext.util.RolestextMinimalModelHelper().getMinimalModel(eClass, allClassesWithSyntax, newFileName);
		if (root == null) {
			// could not create a minimal model. returning an empty document is the best we
			// can do.
			return "";
		}
		// use printer to get text for model
		java.io.ByteArrayOutputStream buffer = new java.io.ByteArrayOutputStream();
		org.emftext.language.refactoring.roles.resource.rolestext.IRolestextTextPrinter printer = getPrinter(buffer);
		try {
			printer.print(root);
		} catch (java.io.IOException e) {
			new org.emftext.language.refactoring.roles.resource.rolestext.util.RolestextRuntimeUtil().logError("Exception while generating example content.", e);
		}
		return buffer.toString();
	}
	
	public org.emftext.language.refactoring.roles.resource.rolestext.IRolestextTextPrinter getPrinter(java.io.OutputStream outputStream) {
		return getMetaInformation().createPrinter(outputStream, new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextResource());
	}
	
}
