/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.emftext.language.refactoring.roles.resource.rolestext.mopp;

public class RolestextProblem implements org.emftext.language.refactoring.roles.resource.rolestext.IRolestextProblem {
	
	private String message;
	private org.emftext.language.refactoring.roles.resource.rolestext.RolestextEProblemType type;
	private org.emftext.language.refactoring.roles.resource.rolestext.RolestextEProblemSeverity severity;
	private java.util.Collection<org.emftext.language.refactoring.roles.resource.rolestext.IRolestextQuickFix> quickFixes;
	
	public RolestextProblem(String message, org.emftext.language.refactoring.roles.resource.rolestext.RolestextEProblemType type, org.emftext.language.refactoring.roles.resource.rolestext.RolestextEProblemSeverity severity) {
		this(message, type, severity, java.util.Collections.<org.emftext.language.refactoring.roles.resource.rolestext.IRolestextQuickFix>emptySet());
	}
	
	public RolestextProblem(String message, org.emftext.language.refactoring.roles.resource.rolestext.RolestextEProblemType type, org.emftext.language.refactoring.roles.resource.rolestext.RolestextEProblemSeverity severity, org.emftext.language.refactoring.roles.resource.rolestext.IRolestextQuickFix quickFix) {
		this(message, type, severity, java.util.Collections.singleton(quickFix));
	}
	
	public RolestextProblem(String message, org.emftext.language.refactoring.roles.resource.rolestext.RolestextEProblemType type, org.emftext.language.refactoring.roles.resource.rolestext.RolestextEProblemSeverity severity, java.util.Collection<org.emftext.language.refactoring.roles.resource.rolestext.IRolestextQuickFix> quickFixes) {
		super();
		this.message = message;
		this.type = type;
		this.severity = severity;
		this.quickFixes = new java.util.LinkedHashSet<org.emftext.language.refactoring.roles.resource.rolestext.IRolestextQuickFix>();
		this.quickFixes.addAll(quickFixes);
	}
	
	public org.emftext.language.refactoring.roles.resource.rolestext.RolestextEProblemType getType() {
		return type;
	}
	
	public org.emftext.language.refactoring.roles.resource.rolestext.RolestextEProblemSeverity getSeverity() {
		return severity;
	}
	
	public String getMessage() {
		return message;
	}
	
	public java.util.Collection<org.emftext.language.refactoring.roles.resource.rolestext.IRolestextQuickFix> getQuickFixes() {
		return quickFixes;
	}
	
}
