/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.emftext.language.refactoring.roles.resource.rolestext.mopp;

public class RolestextTokenStyleInformationProvider {
	
	public static String TASK_ITEM_TOKEN_NAME = "TASK_ITEM";
	
	public org.emftext.language.refactoring.roles.resource.rolestext.IRolestextTokenStyle getDefaultTokenStyle(String tokenName) {
		if ("ML_COMMENT".equals(tokenName)) {
			return new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextTokenStyle(new int[] {0x00, 0x80, 0x00}, null, false, true, false, false);
		}
		if ("SL_COMMENT".equals(tokenName)) {
			return new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextTokenStyle(new int[] {0x00, 0x80, 0x00}, null, false, true, false, false);
		}
		if ("|-|".equals(tokenName)) {
			return new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextTokenStyle(new int[] {0xFF, 0x00, 0x00}, null, true, false, false, false);
		}
		if ("->".equals(tokenName)) {
			return new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextTokenStyle(new int[] {0xFF, 0xC4, 0x00}, null, true, false, false, false);
		}
		if ("--".equals(tokenName)) {
			return new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextTokenStyle(new int[] {0x00, 0xFF, 0x00}, null, true, false, false, false);
		}
		if ("<>-".equals(tokenName)) {
			return new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextTokenStyle(new int[] {0x00, 0xFF, 0xFF}, null, true, false, false, false);
		}
		if ("NUMBER".equals(tokenName)) {
			return new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextTokenStyle(new int[] {0x00, 0x00, 0xFF}, null, false, true, false, false);
		}
		if ("..".equals(tokenName)) {
			return new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextTokenStyle(new int[] {0x00, 0x00, 0xFF}, null, false, true, false, false);
		}
		if ("ROLE_MODIFIER".equals(tokenName)) {
			return new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextTokenStyle(new int[] {0x7F, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("RELATION_MODIFIER".equals(tokenName)) {
			return new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextTokenStyle(new int[] {0x7F, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("RoleModel".equals(tokenName)) {
			return new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("ROLE".equals(tokenName)) {
			return new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("TASK_ITEM".equals(tokenName)) {
			return new org.emftext.language.refactoring.roles.resource.rolestext.mopp.RolestextTokenStyle(new int[] {0x7F, 0x9F, 0xBF}, null, true, false, false, false);
		}
		return null;
	}
	
}
