/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.emftext.language.refactoring.specification.resource.grammar;

/**
 * This class provides the follow sets for all terminals of the grammar. These
 * sets are used during code completion.
 */
public class RefspecFollowSetProvider {
	
	public final static org.emftext.language.refactoring.specification.resource.IRefspecExpectedElement TERMINALS[] = new org.emftext.language.refactoring.specification.resource.IRefspecExpectedElement[68];
	
	public final static org.eclipse.emf.ecore.EStructuralFeature[] FEATURES = new org.eclipse.emf.ecore.EStructuralFeature[17];
	
	public final static org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] LINKS = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[92];
	
	public final static org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] EMPTY_LINK_ARRAY = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[0];
	
	public static void initializeTerminals0() {
		TERMINALS[0] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_0_0_0_0);
		TERMINALS[1] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_0_0_0_2);
		TERMINALS[2] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedStructuralFeature(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_0_0_0_4);
		TERMINALS[3] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_0_0_0_7);
		TERMINALS[4] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_0_0_0_8);
		TERMINALS[5] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_1_0_0_0);
		TERMINALS[6] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_2_0_0_0);
		TERMINALS[7] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_4_0_0_0);
		TERMINALS[8] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_5_0_0_0);
		TERMINALS[9] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_8_0_0_0);
		TERMINALS[10] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_17_0_0_0);
		TERMINALS[11] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_18_0_0_0);
		TERMINALS[12] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_19_0_0_0);
		TERMINALS[13] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_20_0_0_0);
		TERMINALS[14] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_22_0_0_0);
		TERMINALS[15] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_0_0_0_12);
		TERMINALS[16] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_0_0_0_10_0_0_1);
		TERMINALS[17] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_1_0_0_2);
		TERMINALS[18] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedStructuralFeature(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_6_0_0_0);
		TERMINALS[19] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_1_0_0_6);
		TERMINALS[20] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedStructuralFeature(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_1_0_0_8);
		TERMINALS[21] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_1_0_0_9_0_0_1);
		TERMINALS[22] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedStructuralFeature(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_7_0_0_0);
		TERMINALS[23] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedStructuralFeature(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_11_0_0_0);
		TERMINALS[24] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_1_0_0_9_0_0_4_0_0_0);
		TERMINALS[25] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedStructuralFeature(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_1_0_0_9_0_0_4_0_0_1);
		TERMINALS[26] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedStructuralFeature(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_12_0_0_0);
		TERMINALS[27] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_2_0_0_4);
		TERMINALS[28] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_2_0_0_7_0_0_0);
		TERMINALS[29] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_3_0_0_0);
		TERMINALS[30] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedStructuralFeature(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_2_0_0_7_0_0_1);
		TERMINALS[31] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_4_0_0_2);
		TERMINALS[32] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_4_0_0_4);
		TERMINALS[33] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_4_0_0_8);
		TERMINALS[34] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedStructuralFeature(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_5_0_0_2_0_0_0);
		TERMINALS[35] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedStructuralFeature(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_5_0_0_3);
		TERMINALS[36] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_5_0_0_2_0_0_2);
		TERMINALS[37] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_8_0_0_2);
		TERMINALS[38] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_10_0_0_5);
		TERMINALS[39] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_13_0_0_4);
		TERMINALS[40] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_17_0_0_6);
		TERMINALS[41] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_18_0_0_6);
		TERMINALS[42] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_19_0_0_6);
		TERMINALS[43] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedStructuralFeature(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_9_0_0_0);
		TERMINALS[44] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedStructuralFeature(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_10_0_0_0);
		TERMINALS[45] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_9_0_0_2);
		TERMINALS[46] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_14_0_0_0);
		TERMINALS[47] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_15_0_0_0);
		TERMINALS[48] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_16_0_0_0);
		TERMINALS[49] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_10_0_0_1);
		TERMINALS[50] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_10_0_0_2);
		TERMINALS[51] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_10_0_0_3);
		TERMINALS[52] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_13_0_0_2);
		TERMINALS[53] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedStructuralFeature(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_21_0_0_0);
		TERMINALS[54] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_17_0_0_2);
		TERMINALS[55] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_17_0_0_3);
		TERMINALS[56] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_17_0_0_4);
		TERMINALS[57] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_18_0_0_2);
		TERMINALS[58] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_18_0_0_3);
		TERMINALS[59] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_18_0_0_4);
		TERMINALS[60] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_19_0_0_2);
		TERMINALS[61] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_19_0_0_3);
		TERMINALS[62] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_19_0_0_4);
		TERMINALS[63] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_20_0_0_2);
		TERMINALS[64] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedStructuralFeature(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_20_0_0_3);
		TERMINALS[65] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_24_0_0_0);
		TERMINALS[66] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedCsString(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_25_0_0_0);
		TERMINALS[67] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecExpectedStructuralFeature(org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.REFSPEC_23_0_0_0);
	}
	
	public static void initializeTerminals() {
		initializeTerminals0();
	}
	
	public static void initializeFeatures0() {
		FEATURES[0] = org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getRefactoringSpecification().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.REFACTORING_SPECIFICATION__INSTRUCTIONS);
		FEATURES[1] = org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableDeclarationCommand().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.VARIABLE_DECLARATION_COMMAND__VARIABLE);
		FEATURES[2] = org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCREATE().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.CREATE__TARGET_CONTEXT);
		FEATURES[3] = org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getMOVE().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.MOVE__SOURCE);
		FEATURES[4] = org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getMOVE().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.MOVE__TARGET);
		FEATURES[5] = org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getMOVE().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.MOVE__MOVE_MODIFIER);
		FEATURES[6] = org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getSET().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.SET__SOURCE);
		FEATURES[7] = org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getSET().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.SET__TARGET);
		FEATURES[8] = org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableAssignment().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.VARIABLE_ASSIGNMENT__ASSIGNMENT);
		FEATURES[9] = org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getFromClause().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.FROM_CLAUSE__OPERATOR);
		FEATURES[10] = org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getRoleReference().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.ROLE_REFERENCE__FROM);
		FEATURES[11] = org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getTRACE().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.TRACE__REFERENCE);
		FEATURES[12] = org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getFromClause().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.FROM_CLAUSE__REFERENCE);
		FEATURES[13] = org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getIndexAssignmentCommand().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.INDEX_ASSIGNMENT_COMMAND__VARIABLE);
		FEATURES[14] = org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getObjectReferenceAssignment().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.OBJECT_REFERENCE_ASSIGNMENT__REFERENCE);
		FEATURES[15] = org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getREMOVE().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.REMOVE__MODIFIER);
		FEATURES[16] = org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getREMOVE().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.REMOVE__REMOVAL);
	}
	
	public static void initializeFeatures() {
		initializeFeatures0();
	}
	
	public static void initializeLinks0() {
		LINKS[0] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCREATE(), FEATURES[0]);
		LINKS[1] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getMOVE(), FEATURES[0]);
		LINKS[2] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getSET(), FEATURES[0]);
		LINKS[3] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getASSIGN(), FEATURES[0]);
		LINKS[4] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableAssignment(), FEATURES[0]);
		LINKS[5] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getFIRST(), FEATURES[0]);
		LINKS[6] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getLAST(), FEATURES[0]);
		LINKS[7] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getAFTER(), FEATURES[0]);
		LINKS[8] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConcreteIndex(), FEATURES[0]);
		LINKS[9] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getREMOVE(), FEATURES[0]);
		LINKS[10] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCREATE(), FEATURES[0]);
		LINKS[11] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getMOVE(), FEATURES[0]);
		LINKS[12] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getSET(), FEATURES[0]);
		LINKS[13] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getASSIGN(), FEATURES[0]);
		LINKS[14] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableAssignment(), FEATURES[0]);
		LINKS[15] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getFIRST(), FEATURES[0]);
		LINKS[16] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getLAST(), FEATURES[0]);
		LINKS[17] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getAFTER(), FEATURES[0]);
		LINKS[18] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConcreteIndex(), FEATURES[0]);
		LINKS[19] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getREMOVE(), FEATURES[0]);
		LINKS[20] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCREATE(), FEATURES[0]);
		LINKS[21] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getMOVE(), FEATURES[0]);
		LINKS[22] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getSET(), FEATURES[0]);
		LINKS[23] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getASSIGN(), FEATURES[0]);
		LINKS[24] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableAssignment(), FEATURES[0]);
		LINKS[25] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getFIRST(), FEATURES[0]);
		LINKS[26] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getLAST(), FEATURES[0]);
		LINKS[27] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getAFTER(), FEATURES[0]);
		LINKS[28] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConcreteIndex(), FEATURES[0]);
		LINKS[29] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getREMOVE(), FEATURES[0]);
		LINKS[30] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariable(), FEATURES[1]);
		LINKS[31] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference(), FEATURES[2]);
		LINKS[32] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCollaborationReference(), FEATURES[2]);
		LINKS[33] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference(), FEATURES[3]);
		LINKS[34] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCollaborationReference(), FEATURES[3]);
		LINKS[35] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConstantsReference(), FEATURES[3]);
		LINKS[36] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference(), FEATURES[4]);
		LINKS[37] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCollaborationReference(), FEATURES[4]);
		LINKS[38] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getDISTINCT(), FEATURES[5]);
		LINKS[39] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getDISTINCT(), FEATURES[5]);
		LINKS[40] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getDISTINCT(), FEATURES[5]);
		LINKS[41] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference(), FEATURES[6]);
		LINKS[42] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCollaborationReference(), FEATURES[6]);
		LINKS[43] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConstantsReference(), FEATURES[6]);
		LINKS[44] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference(), FEATURES[7]);
		LINKS[45] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCollaborationReference(), FEATURES[7]);
		LINKS[46] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariable(), FEATURES[1]);
		LINKS[47] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getRoleReference(), FEATURES[8]);
		LINKS[48] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getTRACE(), FEATURES[8]);
		LINKS[49] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCollaborationReference(), FEATURES[8]);
		LINKS[50] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getUPTREE(), FEATURES[9]);
		LINKS[51] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getFromClause(), FEATURES[10]);
		LINKS[52] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getPATH(), FEATURES[9]);
		LINKS[53] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getFromClause(), FEATURES[10]);
		LINKS[54] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getFILTER(), FEATURES[9]);
		LINKS[55] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getFromClause(), FEATURES[10]);
		LINKS[56] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference(), FEATURES[11]);
		LINKS[57] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConstantsReference(), FEATURES[11]);
		LINKS[58] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference(), FEATURES[12]);
		LINKS[59] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConstantsReference(), FEATURES[12]);
		LINKS[60] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getIndexVariable(), FEATURES[13]);
		LINKS[61] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference(), FEATURES[14]);
		LINKS[62] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConstantsReference(), FEATURES[14]);
		LINKS[63] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getIndexVariable(), FEATURES[13]);
		LINKS[64] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference(), FEATURES[14]);
		LINKS[65] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConstantsReference(), FEATURES[14]);
		LINKS[66] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getIndexVariable(), FEATURES[13]);
		LINKS[67] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference(), FEATURES[14]);
		LINKS[68] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConstantsReference(), FEATURES[14]);
		LINKS[69] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getIndexVariable(), FEATURES[13]);
		LINKS[70] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getUNUSED(), FEATURES[15]);
		LINKS[71] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getEMPTY(), FEATURES[15]);
		LINKS[72] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference(), FEATURES[16]);
		LINKS[73] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCollaborationReference(), FEATURES[16]);
		LINKS[74] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConstantsReference(), FEATURES[16]);
		LINKS[75] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getRoleRemoval(), FEATURES[16]);
		LINKS[76] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference(), FEATURES[16]);
		LINKS[77] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCollaborationReference(), FEATURES[16]);
		LINKS[78] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConstantsReference(), FEATURES[16]);
		LINKS[79] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getRoleRemoval(), FEATURES[16]);
		LINKS[80] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference(), FEATURES[16]);
		LINKS[81] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCollaborationReference(), FEATURES[16]);
		LINKS[82] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConstantsReference(), FEATURES[16]);
		LINKS[83] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getRoleRemoval(), FEATURES[16]);
		LINKS[84] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference(), FEATURES[16]);
		LINKS[85] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCollaborationReference(), FEATURES[16]);
		LINKS[86] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConstantsReference(), FEATURES[16]);
		LINKS[87] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getRoleRemoval(), FEATURES[16]);
		LINKS[88] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference(), FEATURES[16]);
		LINKS[89] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCollaborationReference(), FEATURES[16]);
		LINKS[90] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConstantsReference(), FEATURES[16]);
		LINKS[91] = new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getRoleRemoval(), FEATURES[16]);
	}
	
	public static void initializeLinks() {
		initializeLinks0();
	}
	
	public static void wire0() {
		TERMINALS[0].addFollower(TERMINALS[1], EMPTY_LINK_ARRAY);
		TERMINALS[1].addFollower(TERMINALS[2], EMPTY_LINK_ARRAY);
		TERMINALS[2].addFollower(TERMINALS[3], EMPTY_LINK_ARRAY);
		TERMINALS[3].addFollower(TERMINALS[4], EMPTY_LINK_ARRAY);
		TERMINALS[4].addFollower(TERMINALS[5], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCREATE(), FEATURES[0]), });
		TERMINALS[4].addFollower(TERMINALS[6], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getMOVE(), FEATURES[0]), });
		TERMINALS[4].addFollower(TERMINALS[7], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getSET(), FEATURES[0]), });
		TERMINALS[4].addFollower(TERMINALS[8], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getASSIGN(), FEATURES[0]), });
		TERMINALS[4].addFollower(TERMINALS[9], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableAssignment(), FEATURES[0]), });
		TERMINALS[4].addFollower(TERMINALS[10], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getFIRST(), FEATURES[0]), });
		TERMINALS[4].addFollower(TERMINALS[11], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getLAST(), FEATURES[0]), });
		TERMINALS[4].addFollower(TERMINALS[12], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getAFTER(), FEATURES[0]), });
		TERMINALS[4].addFollower(TERMINALS[13], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConcreteIndex(), FEATURES[0]), });
		TERMINALS[4].addFollower(TERMINALS[14], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getREMOVE(), FEATURES[0]), });
		TERMINALS[4].addFollower(TERMINALS[15], EMPTY_LINK_ARRAY);
		TERMINALS[16].addFollower(TERMINALS[5], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCREATE(), FEATURES[0]), });
		TERMINALS[16].addFollower(TERMINALS[6], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getMOVE(), FEATURES[0]), });
		TERMINALS[16].addFollower(TERMINALS[7], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getSET(), FEATURES[0]), });
		TERMINALS[16].addFollower(TERMINALS[8], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getASSIGN(), FEATURES[0]), });
		TERMINALS[16].addFollower(TERMINALS[9], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableAssignment(), FEATURES[0]), });
		TERMINALS[16].addFollower(TERMINALS[10], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getFIRST(), FEATURES[0]), });
		TERMINALS[16].addFollower(TERMINALS[11], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getLAST(), FEATURES[0]), });
		TERMINALS[16].addFollower(TERMINALS[12], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getAFTER(), FEATURES[0]), });
		TERMINALS[16].addFollower(TERMINALS[13], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConcreteIndex(), FEATURES[0]), });
		TERMINALS[16].addFollower(TERMINALS[14], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getREMOVE(), FEATURES[0]), });
		TERMINALS[16].addFollower(TERMINALS[15], EMPTY_LINK_ARRAY);
		TERMINALS[5].addFollower(TERMINALS[17], EMPTY_LINK_ARRAY);
		TERMINALS[17].addFollower(TERMINALS[18], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariable(), FEATURES[1]), });
		TERMINALS[19].addFollower(TERMINALS[20], EMPTY_LINK_ARRAY);
		TERMINALS[20].addFollower(TERMINALS[21], EMPTY_LINK_ARRAY);
		TERMINALS[20].addFollower(TERMINALS[16], EMPTY_LINK_ARRAY);
		TERMINALS[21].addFollower(TERMINALS[22], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference(), FEATURES[2]), });
		TERMINALS[21].addFollower(TERMINALS[23], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCollaborationReference(), FEATURES[2]), });
		TERMINALS[24].addFollower(TERMINALS[25], EMPTY_LINK_ARRAY);
		TERMINALS[25].addFollower(TERMINALS[16], EMPTY_LINK_ARRAY);
		TERMINALS[6].addFollower(TERMINALS[22], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference(), FEATURES[3]), });
		TERMINALS[6].addFollower(TERMINALS[23], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCollaborationReference(), FEATURES[3]), });
		TERMINALS[6].addFollower(TERMINALS[26], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConstantsReference(), FEATURES[3]), });
		TERMINALS[27].addFollower(TERMINALS[22], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference(), FEATURES[4]), });
		TERMINALS[27].addFollower(TERMINALS[23], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCollaborationReference(), FEATURES[4]), });
		TERMINALS[28].addFollower(TERMINALS[30], EMPTY_LINK_ARRAY);
		TERMINALS[30].addFollower(TERMINALS[29], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getDISTINCT(), FEATURES[5]), });
		TERMINALS[30].addFollower(TERMINALS[16], EMPTY_LINK_ARRAY);
		TERMINALS[29].addFollower(TERMINALS[16], EMPTY_LINK_ARRAY);
		TERMINALS[7].addFollower(TERMINALS[31], EMPTY_LINK_ARRAY);
		TERMINALS[31].addFollower(TERMINALS[32], EMPTY_LINK_ARRAY);
		TERMINALS[32].addFollower(TERMINALS[22], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference(), FEATURES[6]), });
		TERMINALS[32].addFollower(TERMINALS[23], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCollaborationReference(), FEATURES[6]), });
		TERMINALS[32].addFollower(TERMINALS[26], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConstantsReference(), FEATURES[6]), });
		TERMINALS[33].addFollower(TERMINALS[22], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference(), FEATURES[7]), });
		TERMINALS[33].addFollower(TERMINALS[23], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCollaborationReference(), FEATURES[7]), });
		TERMINALS[8].addFollower(TERMINALS[34], EMPTY_LINK_ARRAY);
		TERMINALS[8].addFollower(TERMINALS[35], EMPTY_LINK_ARRAY);
		TERMINALS[34].addFollower(TERMINALS[36], EMPTY_LINK_ARRAY);
		TERMINALS[36].addFollower(TERMINALS[35], EMPTY_LINK_ARRAY);
		TERMINALS[35].addFollower(TERMINALS[16], EMPTY_LINK_ARRAY);
		TERMINALS[18].addFollower(TERMINALS[19], EMPTY_LINK_ARRAY);
		TERMINALS[18].addFollower(TERMINALS[37], EMPTY_LINK_ARRAY);
		TERMINALS[22].addFollower(TERMINALS[24], EMPTY_LINK_ARRAY);
		TERMINALS[22].addFollower(TERMINALS[16], EMPTY_LINK_ARRAY);
		TERMINALS[22].addFollower(TERMINALS[27], EMPTY_LINK_ARRAY);
		TERMINALS[22].addFollower(TERMINALS[33], EMPTY_LINK_ARRAY);
		TERMINALS[22].addFollower(TERMINALS[38], EMPTY_LINK_ARRAY);
		TERMINALS[22].addFollower(TERMINALS[39], EMPTY_LINK_ARRAY);
		TERMINALS[22].addFollower(TERMINALS[40], EMPTY_LINK_ARRAY);
		TERMINALS[22].addFollower(TERMINALS[41], EMPTY_LINK_ARRAY);
		TERMINALS[22].addFollower(TERMINALS[42], EMPTY_LINK_ARRAY);
		TERMINALS[9].addFollower(TERMINALS[18], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariable(), FEATURES[1]), });
		TERMINALS[37].addFollower(TERMINALS[43], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getRoleReference(), FEATURES[8]), });
		TERMINALS[37].addFollower(TERMINALS[44], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getTRACE(), FEATURES[8]), });
		TERMINALS[37].addFollower(TERMINALS[23], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCollaborationReference(), FEATURES[8]), });
		TERMINALS[43].addFollower(TERMINALS[45], EMPTY_LINK_ARRAY);
		TERMINALS[45].addFollower(TERMINALS[46], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getUPTREE(), FEATURES[9]), new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getFromClause(), FEATURES[10]), });
		TERMINALS[45].addFollower(TERMINALS[47], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getPATH(), FEATURES[9]), new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getFromClause(), FEATURES[10]), });
		TERMINALS[45].addFollower(TERMINALS[48], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getFILTER(), FEATURES[9]), new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getFromClause(), FEATURES[10]), });
		TERMINALS[44].addFollower(TERMINALS[49], EMPTY_LINK_ARRAY);
		TERMINALS[49].addFollower(TERMINALS[50], EMPTY_LINK_ARRAY);
		TERMINALS[50].addFollower(TERMINALS[51], EMPTY_LINK_ARRAY);
		TERMINALS[51].addFollower(TERMINALS[22], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference(), FEATURES[11]), });
		TERMINALS[51].addFollower(TERMINALS[26], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConstantsReference(), FEATURES[11]), });
		TERMINALS[38].addFollower(TERMINALS[16], EMPTY_LINK_ARRAY);
		TERMINALS[23].addFollower(TERMINALS[24], EMPTY_LINK_ARRAY);
		TERMINALS[23].addFollower(TERMINALS[16], EMPTY_LINK_ARRAY);
		TERMINALS[23].addFollower(TERMINALS[27], EMPTY_LINK_ARRAY);
		TERMINALS[23].addFollower(TERMINALS[33], EMPTY_LINK_ARRAY);
		TERMINALS[26].addFollower(TERMINALS[27], EMPTY_LINK_ARRAY);
		TERMINALS[26].addFollower(TERMINALS[33], EMPTY_LINK_ARRAY);
		TERMINALS[26].addFollower(TERMINALS[38], EMPTY_LINK_ARRAY);
		TERMINALS[26].addFollower(TERMINALS[39], EMPTY_LINK_ARRAY);
		TERMINALS[26].addFollower(TERMINALS[40], EMPTY_LINK_ARRAY);
		TERMINALS[26].addFollower(TERMINALS[41], EMPTY_LINK_ARRAY);
		TERMINALS[26].addFollower(TERMINALS[42], EMPTY_LINK_ARRAY);
		TERMINALS[26].addFollower(TERMINALS[16], EMPTY_LINK_ARRAY);
		TERMINALS[52].addFollower(TERMINALS[22], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference(), FEATURES[12]), });
		TERMINALS[52].addFollower(TERMINALS[26], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConstantsReference(), FEATURES[12]), });
		TERMINALS[39].addFollower(TERMINALS[16], EMPTY_LINK_ARRAY);
		TERMINALS[46].addFollower(TERMINALS[52], EMPTY_LINK_ARRAY);
		TERMINALS[47].addFollower(TERMINALS[52], EMPTY_LINK_ARRAY);
		TERMINALS[48].addFollower(TERMINALS[52], EMPTY_LINK_ARRAY);
		TERMINALS[10].addFollower(TERMINALS[53], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getIndexVariable(), FEATURES[13]), });
		TERMINALS[54].addFollower(TERMINALS[55], EMPTY_LINK_ARRAY);
		TERMINALS[55].addFollower(TERMINALS[56], EMPTY_LINK_ARRAY);
		TERMINALS[56].addFollower(TERMINALS[22], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference(), FEATURES[14]), });
		TERMINALS[56].addFollower(TERMINALS[26], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConstantsReference(), FEATURES[14]), });
		TERMINALS[40].addFollower(TERMINALS[16], EMPTY_LINK_ARRAY);
		TERMINALS[11].addFollower(TERMINALS[53], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getIndexVariable(), FEATURES[13]), });
		TERMINALS[57].addFollower(TERMINALS[58], EMPTY_LINK_ARRAY);
		TERMINALS[58].addFollower(TERMINALS[59], EMPTY_LINK_ARRAY);
		TERMINALS[59].addFollower(TERMINALS[22], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference(), FEATURES[14]), });
		TERMINALS[59].addFollower(TERMINALS[26], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConstantsReference(), FEATURES[14]), });
		TERMINALS[41].addFollower(TERMINALS[16], EMPTY_LINK_ARRAY);
		TERMINALS[12].addFollower(TERMINALS[53], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getIndexVariable(), FEATURES[13]), });
		TERMINALS[60].addFollower(TERMINALS[61], EMPTY_LINK_ARRAY);
		TERMINALS[61].addFollower(TERMINALS[62], EMPTY_LINK_ARRAY);
		TERMINALS[62].addFollower(TERMINALS[22], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference(), FEATURES[14]), });
		TERMINALS[62].addFollower(TERMINALS[26], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConstantsReference(), FEATURES[14]), });
		TERMINALS[42].addFollower(TERMINALS[16], EMPTY_LINK_ARRAY);
		TERMINALS[13].addFollower(TERMINALS[53], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getIndexVariable(), FEATURES[13]), });
		TERMINALS[63].addFollower(TERMINALS[64], EMPTY_LINK_ARRAY);
		TERMINALS[64].addFollower(TERMINALS[16], EMPTY_LINK_ARRAY);
		TERMINALS[53].addFollower(TERMINALS[54], EMPTY_LINK_ARRAY);
		TERMINALS[53].addFollower(TERMINALS[57], EMPTY_LINK_ARRAY);
		TERMINALS[53].addFollower(TERMINALS[60], EMPTY_LINK_ARRAY);
		TERMINALS[53].addFollower(TERMINALS[63], EMPTY_LINK_ARRAY);
		TERMINALS[14].addFollower(TERMINALS[65], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getUNUSED(), FEATURES[15]), });
		TERMINALS[14].addFollower(TERMINALS[66], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getEMPTY(), FEATURES[15]), });
		TERMINALS[14].addFollower(TERMINALS[22], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference(), FEATURES[16]), });
		TERMINALS[14].addFollower(TERMINALS[23], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCollaborationReference(), FEATURES[16]), });
		TERMINALS[14].addFollower(TERMINALS[26], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConstantsReference(), FEATURES[16]), });
		TERMINALS[14].addFollower(TERMINALS[67], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getRoleRemoval(), FEATURES[16]), });
		TERMINALS[67].addFollower(TERMINALS[16], EMPTY_LINK_ARRAY);
		TERMINALS[65].addFollower(TERMINALS[22], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference(), FEATURES[16]), });
		TERMINALS[65].addFollower(TERMINALS[23], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCollaborationReference(), FEATURES[16]), });
		TERMINALS[65].addFollower(TERMINALS[26], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConstantsReference(), FEATURES[16]), });
		TERMINALS[65].addFollower(TERMINALS[67], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getRoleRemoval(), FEATURES[16]), });
		TERMINALS[66].addFollower(TERMINALS[22], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference(), FEATURES[16]), });
		TERMINALS[66].addFollower(TERMINALS[23], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCollaborationReference(), FEATURES[16]), });
		TERMINALS[66].addFollower(TERMINALS[26], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConstantsReference(), FEATURES[16]), });
		TERMINALS[66].addFollower(TERMINALS[67], new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature[] {new org.emftext.language.refactoring.specification.resource.mopp.RefspecContainedFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getRoleRemoval(), FEATURES[16]), });
	}
	
	public static void wire() {
		wire0();
	}
	
	static {
		// initialize the arrays
		initializeTerminals();
		initializeFeatures();
		initializeLinks();
		// wire the terminals
		wire();
	}
}
