/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.emftext.language.refactoring.specification.resource.grammar;

public class RefspecGrammarInformationProvider {
	
	public final static org.eclipse.emf.ecore.EStructuralFeature ANONYMOUS_FEATURE = org.eclipse.emf.ecore.EcoreFactory.eINSTANCE.createEAttribute();
	static {
		ANONYMOUS_FEATURE.setName("_");
	}
	
	public final static RefspecGrammarInformationProvider INSTANCE = new RefspecGrammarInformationProvider();
	
	private java.util.Set<String> keywords;
	
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_0_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("REFACTORING", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace REFSPEC_0_0_0_1 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace(1, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_0_0_0_2 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("FOR", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace REFSPEC_0_0_0_3 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace(1, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecPlaceholder REFSPEC_0_0_0_4 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecPlaceholder(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getRefactoringSpecification().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.REFACTORING_SPECIFICATION__USED_ROLE_MODEL), "QUOTED_60_62", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecLineBreak REFSPEC_0_0_0_5 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecLineBreak(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecLineBreak REFSPEC_0_0_0_6 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecLineBreak(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_0_0_0_7 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("STEPS", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_0_0_0_8 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("{", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecLineBreak REFSPEC_0_0_0_9 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecLineBreak(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, 1);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment REFSPEC_0_0_0_10_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getRefactoringSpecification().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.REFACTORING_SPECIFICATION__INSTRUCTIONS), org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, new org.eclipse.emf.ecore.EClass[] {org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getInstruction(), }, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_0_0_0_10_0_0_1 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword(";", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecLineBreak REFSPEC_0_0_0_10_0_0_2 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecLineBreak(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_0_0_0_10_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_0_0_0_10_0_0_0, REFSPEC_0_0_0_10_0_0_1, REFSPEC_0_0_0_10_0_0_2);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_0_0_0_10_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_0_0_0_10_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecCompound REFSPEC_0_0_0_10 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecCompound(REFSPEC_0_0_0_10_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.STAR);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecLineBreak REFSPEC_0_0_0_11 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecLineBreak(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_0_0_0_12 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("}", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_0_0_0_0, REFSPEC_0_0_0_1, REFSPEC_0_0_0_2, REFSPEC_0_0_0_3, REFSPEC_0_0_0_4, REFSPEC_0_0_0_5, REFSPEC_0_0_0_6, REFSPEC_0_0_0_7, REFSPEC_0_0_0_8, REFSPEC_0_0_0_9, REFSPEC_0_0_0_10, REFSPEC_0_0_0_11, REFSPEC_0_0_0_12);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_0_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecRule REFSPEC_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecRule(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getRefactoringSpecification(), REFSPEC_0_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_1_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("create", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace REFSPEC_1_0_0_1 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace(1, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_1_0_0_2 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("new", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace REFSPEC_1_0_0_3 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace(1, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment REFSPEC_1_0_0_4 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCREATE().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.CREATE__VARIABLE), org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, new org.eclipse.emf.ecore.EClass[] {org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariable(), }, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace REFSPEC_1_0_0_5 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace(0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_1_0_0_6 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword(":", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace REFSPEC_1_0_0_7 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace(0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecPlaceholder REFSPEC_1_0_0_8 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecPlaceholder(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCREATE().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.CREATE__SOURCE_ROLE), "UPPER_IDENTIFIER", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace REFSPEC_1_0_0_9_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace(1, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_1_0_0_9_0_0_1 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("in", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace REFSPEC_1_0_0_9_0_0_2 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace(1, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment REFSPEC_1_0_0_9_0_0_3 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCREATE().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.CREATE__TARGET_CONTEXT), org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, new org.eclipse.emf.ecore.EClass[] {org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getTargetContext(), }, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_1_0_0_9_0_0_4_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("at", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecPlaceholder REFSPEC_1_0_0_9_0_0_4_0_0_1 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecPlaceholder(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCREATE().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.CREATE__INDEX), "LOWER_IDENTIFIER", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_1_0_0_9_0_0_4_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_1_0_0_9_0_0_4_0_0_0, REFSPEC_1_0_0_9_0_0_4_0_0_1);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_1_0_0_9_0_0_4_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_1_0_0_9_0_0_4_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecCompound REFSPEC_1_0_0_9_0_0_4 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecCompound(REFSPEC_1_0_0_9_0_0_4_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.QUESTIONMARK);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_1_0_0_9_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_1_0_0_9_0_0_0, REFSPEC_1_0_0_9_0_0_1, REFSPEC_1_0_0_9_0_0_2, REFSPEC_1_0_0_9_0_0_3, REFSPEC_1_0_0_9_0_0_4);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_1_0_0_9_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_1_0_0_9_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecCompound REFSPEC_1_0_0_9 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecCompound(REFSPEC_1_0_0_9_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.QUESTIONMARK);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_1_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_1_0_0_0, REFSPEC_1_0_0_1, REFSPEC_1_0_0_2, REFSPEC_1_0_0_3, REFSPEC_1_0_0_4, REFSPEC_1_0_0_5, REFSPEC_1_0_0_6, REFSPEC_1_0_0_7, REFSPEC_1_0_0_8, REFSPEC_1_0_0_9);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_1_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_1_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecRule REFSPEC_1 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecRule(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCREATE(), REFSPEC_1_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_2_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("move", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace REFSPEC_2_0_0_1 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace(1, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment REFSPEC_2_0_0_2 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getMOVE().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.MOVE__SOURCE), org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, new org.eclipse.emf.ecore.EClass[] {org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getSourceContext(), }, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace REFSPEC_2_0_0_3 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace(1, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_2_0_0_4 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("to", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace REFSPEC_2_0_0_5 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace(1, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment REFSPEC_2_0_0_6 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getMOVE().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.MOVE__TARGET), org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, new org.eclipse.emf.ecore.EClass[] {org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getTargetContext(), }, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_2_0_0_7_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("at", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecPlaceholder REFSPEC_2_0_0_7_0_0_1 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecPlaceholder(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getMOVE().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.MOVE__INDEX), "LOWER_IDENTIFIER", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_2_0_0_7_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_2_0_0_7_0_0_0, REFSPEC_2_0_0_7_0_0_1);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_2_0_0_7_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_2_0_0_7_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecCompound REFSPEC_2_0_0_7 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecCompound(REFSPEC_2_0_0_7_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.QUESTIONMARK);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment REFSPEC_2_0_0_8_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getMOVE().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.MOVE__MOVE_MODIFIER), org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, new org.eclipse.emf.ecore.EClass[] {org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getModifier(), }, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_2_0_0_8_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_2_0_0_8_0_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_2_0_0_8_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_2_0_0_8_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecCompound REFSPEC_2_0_0_8 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecCompound(REFSPEC_2_0_0_8_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.QUESTIONMARK);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_2_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_2_0_0_0, REFSPEC_2_0_0_1, REFSPEC_2_0_0_2, REFSPEC_2_0_0_3, REFSPEC_2_0_0_4, REFSPEC_2_0_0_5, REFSPEC_2_0_0_6, REFSPEC_2_0_0_7, REFSPEC_2_0_0_8);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_2_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_2_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecRule REFSPEC_2 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecRule(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getMOVE(), REFSPEC_2_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_3_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("distinct", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_3_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_3_0_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_3_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_3_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecRule REFSPEC_3 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecRule(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getDISTINCT(), REFSPEC_3_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_4_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("set", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace REFSPEC_4_0_0_1 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace(1, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_4_0_0_2 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("use", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace REFSPEC_4_0_0_3 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace(1, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_4_0_0_4 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("of", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace REFSPEC_4_0_0_5 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace(1, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment REFSPEC_4_0_0_6 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getSET().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.SET__SOURCE), org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, new org.eclipse.emf.ecore.EClass[] {org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getSourceContext(), }, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace REFSPEC_4_0_0_7 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace(1, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_4_0_0_8 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("in", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace REFSPEC_4_0_0_9 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace(1, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment REFSPEC_4_0_0_10 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getSET().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.SET__TARGET), org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, new org.eclipse.emf.ecore.EClass[] {org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getTargetContext(), }, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_4_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_4_0_0_0, REFSPEC_4_0_0_1, REFSPEC_4_0_0_2, REFSPEC_4_0_0_3, REFSPEC_4_0_0_4, REFSPEC_4_0_0_5, REFSPEC_4_0_0_6, REFSPEC_4_0_0_7, REFSPEC_4_0_0_8, REFSPEC_4_0_0_9, REFSPEC_4_0_0_10);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_4_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_4_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecRule REFSPEC_4 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecRule(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getSET(), REFSPEC_4_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_5_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("assign", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace REFSPEC_5_0_0_1 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace(1, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecPlaceholder REFSPEC_5_0_0_2_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecPlaceholder(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getASSIGN().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.ASSIGN__SOURCE_ATTRIBUTE), "DOT_NOTATION", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace REFSPEC_5_0_0_2_0_0_1 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace(1, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_5_0_0_2_0_0_2 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("for", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace REFSPEC_5_0_0_2_0_0_3 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace(1, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_5_0_0_2_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_5_0_0_2_0_0_0, REFSPEC_5_0_0_2_0_0_1, REFSPEC_5_0_0_2_0_0_2, REFSPEC_5_0_0_2_0_0_3);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_5_0_0_2_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_5_0_0_2_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecCompound REFSPEC_5_0_0_2 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecCompound(REFSPEC_5_0_0_2_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.QUESTIONMARK);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecPlaceholder REFSPEC_5_0_0_3 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecPlaceholder(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getASSIGN().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.ASSIGN__TARGET_ATTRIBUTE), "DOT_NOTATION", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_5_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_5_0_0_0, REFSPEC_5_0_0_1, REFSPEC_5_0_0_2, REFSPEC_5_0_0_3);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_5_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_5_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecRule REFSPEC_5 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecRule(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getASSIGN(), REFSPEC_5_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecPlaceholder REFSPEC_6_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecPlaceholder(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariable().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.VARIABLE__NAME), "LOWER_IDENTIFIER", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_6_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_6_0_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_6_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_6_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecRule REFSPEC_6 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecRule(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariable(), REFSPEC_6_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecPlaceholder REFSPEC_7_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecPlaceholder(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.VARIABLE_REFERENCE__VARIABLE), "LOWER_IDENTIFIER", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_7_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_7_0_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_7_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_7_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecRule REFSPEC_7 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecRule(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference(), REFSPEC_7_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_8_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("object", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment REFSPEC_8_0_0_1 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableAssignment().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.VARIABLE_ASSIGNMENT__VARIABLE), org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, new org.eclipse.emf.ecore.EClass[] {org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariable(), }, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_8_0_0_2 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword(":=", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment REFSPEC_8_0_0_3 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableAssignment().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.VARIABLE_ASSIGNMENT__ASSIGNMENT), org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, new org.eclipse.emf.ecore.EClass[] {org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getObjectAssignmentCommand(), }, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_8_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_8_0_0_0, REFSPEC_8_0_0_1, REFSPEC_8_0_0_2, REFSPEC_8_0_0_3);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_8_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_8_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecRule REFSPEC_8 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecRule(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableAssignment(), REFSPEC_8_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecPlaceholder REFSPEC_9_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecPlaceholder(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getRoleReference().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.ROLE_REFERENCE__ROLE), "UPPER_IDENTIFIER", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace REFSPEC_9_0_0_1 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace(1, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_9_0_0_2 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("from", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace REFSPEC_9_0_0_3 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace(1, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment REFSPEC_9_0_0_4 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getRoleReference().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.ROLE_REFERENCE__FROM), org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, new org.eclipse.emf.ecore.EClass[] {org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getFromClause(), }, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_9_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_9_0_0_0, REFSPEC_9_0_0_1, REFSPEC_9_0_0_2, REFSPEC_9_0_0_3, REFSPEC_9_0_0_4);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_9_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_9_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecRule REFSPEC_9 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecRule(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getRoleReference(), REFSPEC_9_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecPlaceholder REFSPEC_10_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecPlaceholder(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getTRACE().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.TRACE__ROLE), "UPPER_IDENTIFIER", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_10_0_0_1 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("as", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_10_0_0_2 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("trace", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_10_0_0_3 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("(", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment REFSPEC_10_0_0_4 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getTRACE().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.TRACE__REFERENCE), org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, new org.eclipse.emf.ecore.EClass[] {org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getObjectReference(), }, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_10_0_0_5 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword(")", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_10_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_10_0_0_0, REFSPEC_10_0_0_1, REFSPEC_10_0_0_2, REFSPEC_10_0_0_3, REFSPEC_10_0_0_4, REFSPEC_10_0_0_5);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_10_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_10_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecRule REFSPEC_10 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecRule(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getTRACE(), REFSPEC_10_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecPlaceholder REFSPEC_11_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecPlaceholder(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCollaborationReference().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.COLLABORATION_REFERENCE__COLLABORATION), "DOT_NOTATION", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_11_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_11_0_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_11_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_11_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecRule REFSPEC_11 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecRule(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCollaborationReference(), REFSPEC_11_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecPlaceholder REFSPEC_12_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecPlaceholder(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConstantsReference().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.CONSTANTS_REFERENCE__REFERENCED_CONSTANT), "CONSTANTS", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_12_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_12_0_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_12_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_12_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecRule REFSPEC_12 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecRule(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConstantsReference(), REFSPEC_12_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment REFSPEC_13_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getFromClause().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.FROM_CLAUSE__OPERATOR), org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, new org.eclipse.emf.ecore.EClass[] {org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getFromOperator(), }, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace REFSPEC_13_0_0_1 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecWhiteSpace(0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_13_0_0_2 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("(", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment REFSPEC_13_0_0_3 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getFromClause().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.FROM_CLAUSE__REFERENCE), org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, new org.eclipse.emf.ecore.EClass[] {org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getObjectReference(), }, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_13_0_0_4 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword(")", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_13_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_13_0_0_0, REFSPEC_13_0_0_1, REFSPEC_13_0_0_2, REFSPEC_13_0_0_3, REFSPEC_13_0_0_4);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_13_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_13_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecRule REFSPEC_13 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecRule(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getFromClause(), REFSPEC_13_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_14_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("uptree", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_14_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_14_0_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_14_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_14_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecRule REFSPEC_14 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecRule(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getUPTREE(), REFSPEC_14_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_15_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("path", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_15_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_15_0_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_15_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_15_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecRule REFSPEC_15 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecRule(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getPATH(), REFSPEC_15_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_16_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("filter", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_16_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_16_0_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_16_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_16_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecRule REFSPEC_16 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecRule(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getFILTER(), REFSPEC_16_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_17_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("index", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment REFSPEC_17_0_0_1 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getFIRST().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.FIRST__VARIABLE), org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, new org.eclipse.emf.ecore.EClass[] {org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getIndexVariable(), }, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_17_0_0_2 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword(":=", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_17_0_0_3 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("first", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_17_0_0_4 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("(", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment REFSPEC_17_0_0_5 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getFIRST().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.FIRST__REFERENCE), org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, new org.eclipse.emf.ecore.EClass[] {org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getObjectReference(), }, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_17_0_0_6 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword(")", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_17_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_17_0_0_0, REFSPEC_17_0_0_1, REFSPEC_17_0_0_2, REFSPEC_17_0_0_3, REFSPEC_17_0_0_4, REFSPEC_17_0_0_5, REFSPEC_17_0_0_6);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_17_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_17_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecRule REFSPEC_17 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecRule(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getFIRST(), REFSPEC_17_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_18_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("index", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment REFSPEC_18_0_0_1 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getLAST().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.LAST__VARIABLE), org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, new org.eclipse.emf.ecore.EClass[] {org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getIndexVariable(), }, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_18_0_0_2 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword(":=", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_18_0_0_3 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("last", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_18_0_0_4 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("(", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment REFSPEC_18_0_0_5 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getLAST().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.LAST__REFERENCE), org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, new org.eclipse.emf.ecore.EClass[] {org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getObjectReference(), }, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_18_0_0_6 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword(")", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_18_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_18_0_0_0, REFSPEC_18_0_0_1, REFSPEC_18_0_0_2, REFSPEC_18_0_0_3, REFSPEC_18_0_0_4, REFSPEC_18_0_0_5, REFSPEC_18_0_0_6);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_18_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_18_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecRule REFSPEC_18 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecRule(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getLAST(), REFSPEC_18_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_19_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("index", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment REFSPEC_19_0_0_1 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getAFTER().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.AFTER__VARIABLE), org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, new org.eclipse.emf.ecore.EClass[] {org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getIndexVariable(), }, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_19_0_0_2 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword(":=", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_19_0_0_3 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("after", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_19_0_0_4 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("(", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment REFSPEC_19_0_0_5 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getAFTER().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.AFTER__REFERENCE), org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, new org.eclipse.emf.ecore.EClass[] {org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getObjectReference(), }, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_19_0_0_6 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword(")", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_19_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_19_0_0_0, REFSPEC_19_0_0_1, REFSPEC_19_0_0_2, REFSPEC_19_0_0_3, REFSPEC_19_0_0_4, REFSPEC_19_0_0_5, REFSPEC_19_0_0_6);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_19_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_19_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecRule REFSPEC_19 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecRule(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getAFTER(), REFSPEC_19_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_20_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("index", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment REFSPEC_20_0_0_1 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConcreteIndex().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.CONCRETE_INDEX__VARIABLE), org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, new org.eclipse.emf.ecore.EClass[] {org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getIndexVariable(), }, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_20_0_0_2 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword(":=", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecPlaceholder REFSPEC_20_0_0_3 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecPlaceholder(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConcreteIndex().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.CONCRETE_INDEX__INDEX), "INTEGER", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_20_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_20_0_0_0, REFSPEC_20_0_0_1, REFSPEC_20_0_0_2, REFSPEC_20_0_0_3);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_20_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_20_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecRule REFSPEC_20 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecRule(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getConcreteIndex(), REFSPEC_20_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecPlaceholder REFSPEC_21_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecPlaceholder(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getIndexVariable().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.INDEX_VARIABLE__NAME), "LOWER_IDENTIFIER", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_21_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_21_0_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_21_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_21_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecRule REFSPEC_21 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecRule(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getIndexVariable(), REFSPEC_21_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_22_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("remove", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment REFSPEC_22_0_0_1_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getREMOVE().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.REMOVE__MODIFIER), org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, new org.eclipse.emf.ecore.EClass[] {org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getRemoveModifier(), }, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_22_0_0_1_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_22_0_0_1_0_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_22_0_0_1_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_22_0_0_1_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecCompound REFSPEC_22_0_0_1 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecCompound(REFSPEC_22_0_0_1_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.QUESTIONMARK);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment REFSPEC_22_0_0_2 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecContainment(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getREMOVE().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.REMOVE__REMOVAL), org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, new org.eclipse.emf.ecore.EClass[] {org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getObjectRemoval(), }, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_22_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_22_0_0_0, REFSPEC_22_0_0_1, REFSPEC_22_0_0_2);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_22_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_22_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecRule REFSPEC_22 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecRule(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getREMOVE(), REFSPEC_22_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecPlaceholder REFSPEC_23_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecPlaceholder(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getRoleRemoval().getEStructuralFeature(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.ROLE_REMOVAL__ROLE), "UPPER_IDENTIFIER", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, 0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_23_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_23_0_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_23_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_23_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecRule REFSPEC_23 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecRule(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getRoleRemoval(), REFSPEC_23_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_24_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("unused", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_24_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_24_0_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_24_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_24_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecRule REFSPEC_24 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecRule(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getUNUSED(), REFSPEC_24_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword REFSPEC_25_0_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword("empty", org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence REFSPEC_25_0_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecSequence(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_25_0_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice REFSPEC_25_0 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecChoice(org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE, REFSPEC_25_0_0);
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecRule REFSPEC_25 = new org.emftext.language.refactoring.specification.resource.grammar.RefspecRule(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getEMPTY(), REFSPEC_25_0, org.emftext.language.refactoring.specification.resource.grammar.RefspecCardinality.ONE);
	
	public static String getSyntaxElementID(org.emftext.language.refactoring.specification.resource.grammar.RefspecSyntaxElement syntaxElement) {
		if (syntaxElement == null) {
			// null indicates EOF
			return "<EOF>";
		}
		for (java.lang.reflect.Field field : org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.class.getFields()) {
			Object fieldValue;
			try {
				fieldValue = field.get(null);
				if (fieldValue == syntaxElement) {
					String id = field.getName();
					return id;
				}
			} catch (Exception e) { }
		}
		return null;
	}
	
	public static org.emftext.language.refactoring.specification.resource.grammar.RefspecSyntaxElement getSyntaxElementByID(String syntaxElementID) {
		try {
			return (org.emftext.language.refactoring.specification.resource.grammar.RefspecSyntaxElement) org.emftext.language.refactoring.specification.resource.grammar.RefspecGrammarInformationProvider.class.getField(syntaxElementID).get(null);
		} catch (Exception e) {
			return null;
		}
	}
	
	public final static org.emftext.language.refactoring.specification.resource.grammar.RefspecRule[] RULES = new org.emftext.language.refactoring.specification.resource.grammar.RefspecRule[] {
		REFSPEC_0,
		REFSPEC_1,
		REFSPEC_2,
		REFSPEC_3,
		REFSPEC_4,
		REFSPEC_5,
		REFSPEC_6,
		REFSPEC_7,
		REFSPEC_8,
		REFSPEC_9,
		REFSPEC_10,
		REFSPEC_11,
		REFSPEC_12,
		REFSPEC_13,
		REFSPEC_14,
		REFSPEC_15,
		REFSPEC_16,
		REFSPEC_17,
		REFSPEC_18,
		REFSPEC_19,
		REFSPEC_20,
		REFSPEC_21,
		REFSPEC_22,
		REFSPEC_23,
		REFSPEC_24,
		REFSPEC_25,
	};
	
	/**
	 * Returns all keywords of the grammar. This includes all literals for boolean and
	 * enumeration terminals.
	 */
	public java.util.Set<String> getKeywords() {
		if (this.keywords == null) {
			this.keywords = new java.util.LinkedHashSet<String>();
			for (org.emftext.language.refactoring.specification.resource.grammar.RefspecRule rule : RULES) {
				findKeywords(rule, this.keywords);
			}
		}
		return keywords;
	}
	
	/**
	 * Finds all keywords in the given element and its children and adds them to the
	 * set. This includes all literals for boolean and enumeration terminals.
	 */
	private void findKeywords(org.emftext.language.refactoring.specification.resource.grammar.RefspecSyntaxElement element, java.util.Set<String> keywords) {
		if (element instanceof org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword) {
			keywords.add(((org.emftext.language.refactoring.specification.resource.grammar.RefspecKeyword) element).getValue());
		} else if (element instanceof org.emftext.language.refactoring.specification.resource.grammar.RefspecBooleanTerminal) {
			keywords.add(((org.emftext.language.refactoring.specification.resource.grammar.RefspecBooleanTerminal) element).getTrueLiteral());
			keywords.add(((org.emftext.language.refactoring.specification.resource.grammar.RefspecBooleanTerminal) element).getFalseLiteral());
		} else if (element instanceof org.emftext.language.refactoring.specification.resource.grammar.RefspecEnumerationTerminal) {
			org.emftext.language.refactoring.specification.resource.grammar.RefspecEnumerationTerminal terminal = (org.emftext.language.refactoring.specification.resource.grammar.RefspecEnumerationTerminal) element;
			for (String key : terminal.getLiteralMapping().keySet()) {
				keywords.add(key);
			}
		}
		for (org.emftext.language.refactoring.specification.resource.grammar.RefspecSyntaxElement child : element.getChildren()) {
			findKeywords(child, this.keywords);
		}
	}
	
}
