/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.emftext.language.refactoring.specification.resource.mopp;

public class RefspecMetaInformation implements org.emftext.language.refactoring.specification.resource.IRefspecMetaInformation {
	
	public String getSyntaxName() {
		return "refspec";
	}
	
	public String getURI() {
		return "http://www.emftext.org/language/refactoring_specification";
	}
	
	public org.emftext.language.refactoring.specification.resource.IRefspecTextScanner createLexer() {
		return new org.emftext.language.refactoring.specification.resource.mopp.RefspecAntlrScanner(new org.emftext.language.refactoring.specification.resource.mopp.RefspecLexer());
	}
	
	public org.emftext.language.refactoring.specification.resource.IRefspecTextParser createParser(java.io.InputStream inputStream, String encoding) {
		return new org.emftext.language.refactoring.specification.resource.mopp.RefspecParser().createInstance(inputStream, encoding);
	}
	
	public org.emftext.language.refactoring.specification.resource.IRefspecTextPrinter createPrinter(java.io.OutputStream outputStream, org.emftext.language.refactoring.specification.resource.IRefspecTextResource resource) {
		return new org.emftext.language.refactoring.specification.resource.mopp.RefspecPrinter2(outputStream, resource);
	}
	
	public org.eclipse.emf.ecore.EClass[] getClassesWithSyntax() {
		return new org.emftext.language.refactoring.specification.resource.mopp.RefspecSyntaxCoverageInformationProvider().getClassesWithSyntax();
	}
	
	public org.eclipse.emf.ecore.EClass[] getStartSymbols() {
		return new org.emftext.language.refactoring.specification.resource.mopp.RefspecSyntaxCoverageInformationProvider().getStartSymbols();
	}
	
	public org.emftext.language.refactoring.specification.resource.IRefspecReferenceResolverSwitch getReferenceResolverSwitch() {
		return new org.emftext.language.refactoring.specification.resource.mopp.RefspecReferenceResolverSwitch();
	}
	
	public org.emftext.language.refactoring.specification.resource.IRefspecTokenResolverFactory getTokenResolverFactory() {
		return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenResolverFactory();
	}
	
	public String getPathToCSDefinition() {
		return "org.emftext.language.refactoring.specification/metamodel/refactoring_specification.cs";
	}
	
	public String[] getTokenNames() {
		return org.emftext.language.refactoring.specification.resource.mopp.RefspecParser.tokenNames;
	}
	
	public org.emftext.language.refactoring.specification.resource.IRefspecTokenStyle getDefaultTokenStyle(String tokenName) {
		return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyleInformationProvider().getDefaultTokenStyle(tokenName);
	}
	
	public java.util.Collection<org.emftext.language.refactoring.specification.resource.IRefspecBracketPair> getBracketPairs() {
		return new org.emftext.language.refactoring.specification.resource.mopp.RefspecBracketInformationProvider().getBracketPairs();
	}
	
	public org.eclipse.emf.ecore.EClass[] getFoldableClasses() {
		return new org.emftext.language.refactoring.specification.resource.mopp.RefspecFoldingInformationProvider().getFoldableClasses();
	}
	
	public org.eclipse.emf.ecore.resource.Resource.Factory createResourceFactory() {
		return new org.emftext.language.refactoring.specification.resource.mopp.RefspecResourceFactory();
	}
	
	public org.emftext.language.refactoring.specification.resource.mopp.RefspecNewFileContentProvider getNewFileContentProvider() {
		return new org.emftext.language.refactoring.specification.resource.mopp.RefspecNewFileContentProvider();
	}
	
	public void registerResourceFactory() {
		org.eclipse.emf.ecore.resource.Resource.Factory.Registry.INSTANCE.getExtensionToFactoryMap().put(getSyntaxName(), new org.emftext.language.refactoring.specification.resource.mopp.RefspecResourceFactory());
	}
	
	/**
	 * Returns the key of the option that can be used to register a preprocessor that
	 * is used as a pipe when loading resources. This key is language-specific. To
	 * register one preprocessor for multiple resource types, it must be registered
	 * individually using all keys.
	 */
	public String getInputStreamPreprocessorProviderOptionKey() {
		return getSyntaxName() + "_" + "INPUT_STREAM_PREPROCESSOR_PROVIDER";
	}
	
	/**
	 * Returns the key of the option that can be used to register a post-processors
	 * that are invoked after loading resources. This key is language-specific. To
	 * register one post-processor for multiple resource types, it must be registered
	 * individually using all keys.
	 */
	public String getResourcePostProcessorProviderOptionKey() {
		return getSyntaxName() + "_" + "RESOURCE_POSTPROCESSOR_PROVIDER";
	}
	
	public String getLaunchConfigurationType() {
		return "org.emftext.language.refactoring.specification.resource.refspec.ui.launchConfigurationType";
	}
	
	public org.emftext.language.refactoring.specification.resource.IRefspecNameProvider createNameProvider() {
		return new org.emftext.language.refactoring.specification.resource.analysis.RefspecDefaultNameProvider();
	}
	
	public String[] getSyntaxHighlightableTokenNames() {
		org.emftext.language.refactoring.specification.resource.mopp.RefspecAntlrTokenHelper tokenHelper = new org.emftext.language.refactoring.specification.resource.mopp.RefspecAntlrTokenHelper();
		java.util.List<String> highlightableTokens = new java.util.ArrayList<String>();
		String[] parserTokenNames = getTokenNames();
		for (int i = 0; i < parserTokenNames.length; i++) {
			// If ANTLR is used we need to normalize the token names
			if (!tokenHelper.canBeUsedForSyntaxHighlighting(i)) {
				continue;
			}
			String tokenName = tokenHelper.getTokenName(parserTokenNames, i);
			if (tokenName == null) {
				continue;
			}
			highlightableTokens.add(tokenName);
		}
		highlightableTokens.add(org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyleInformationProvider.TASK_ITEM_TOKEN_NAME);
		return highlightableTokens.toArray(new String[highlightableTokens.size()]);
	}
	
}
