/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.emftext.language.refactoring.specification.resource.mopp;

public class RefspecProblem implements org.emftext.language.refactoring.specification.resource.IRefspecProblem {
	
	private String message;
	private org.emftext.language.refactoring.specification.resource.RefspecEProblemType type;
	private org.emftext.language.refactoring.specification.resource.RefspecEProblemSeverity severity;
	private java.util.Collection<org.emftext.language.refactoring.specification.resource.IRefspecQuickFix> quickFixes;
	
	public RefspecProblem(String message, org.emftext.language.refactoring.specification.resource.RefspecEProblemType type, org.emftext.language.refactoring.specification.resource.RefspecEProblemSeverity severity) {
		this(message, type, severity, java.util.Collections.<org.emftext.language.refactoring.specification.resource.IRefspecQuickFix>emptySet());
	}
	
	public RefspecProblem(String message, org.emftext.language.refactoring.specification.resource.RefspecEProblemType type, org.emftext.language.refactoring.specification.resource.RefspecEProblemSeverity severity, org.emftext.language.refactoring.specification.resource.IRefspecQuickFix quickFix) {
		this(message, type, severity, java.util.Collections.singleton(quickFix));
	}
	
	public RefspecProblem(String message, org.emftext.language.refactoring.specification.resource.RefspecEProblemType type, org.emftext.language.refactoring.specification.resource.RefspecEProblemSeverity severity, java.util.Collection<org.emftext.language.refactoring.specification.resource.IRefspecQuickFix> quickFixes) {
		super();
		this.message = message;
		this.type = type;
		this.severity = severity;
		this.quickFixes = new java.util.LinkedHashSet<org.emftext.language.refactoring.specification.resource.IRefspecQuickFix>();
		this.quickFixes.addAll(quickFixes);
	}
	
	public org.emftext.language.refactoring.specification.resource.RefspecEProblemType getType() {
		return type;
	}
	
	public org.emftext.language.refactoring.specification.resource.RefspecEProblemSeverity getSeverity() {
		return severity;
	}
	
	public String getMessage() {
		return message;
	}
	
	public java.util.Collection<org.emftext.language.refactoring.specification.resource.IRefspecQuickFix> getQuickFixes() {
		return quickFixes;
	}
	
}
