/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.emftext.language.refactoring.specification.resource.mopp;

public class RefspecReferenceResolverSwitch implements org.emftext.language.refactoring.specification.resource.IRefspecReferenceResolverSwitch {
	
	/**
	 * This map stores a copy of the options the were set for loading the resource.
	 */
	private java.util.Map<Object, Object> options;
	
	protected org.emftext.language.refactoring.specification.resource.analysis.RefactoringSpecificationUsedRoleModelReferenceResolver refactoringSpecificationUsedRoleModelReferenceResolver = new org.emftext.language.refactoring.specification.resource.analysis.RefactoringSpecificationUsedRoleModelReferenceResolver();
	protected org.emftext.language.refactoring.specification.resource.analysis.CREATESourceRoleReferenceResolver cREATESourceRoleReferenceResolver = new org.emftext.language.refactoring.specification.resource.analysis.CREATESourceRoleReferenceResolver();
	protected org.emftext.language.refactoring.specification.resource.analysis.ContainmentCommandIndexReferenceResolver containmentCommandIndexReferenceResolver = new org.emftext.language.refactoring.specification.resource.analysis.ContainmentCommandIndexReferenceResolver();
	protected org.emftext.language.refactoring.specification.resource.analysis.ASSIGNSourceAttributeReferenceResolver aSSIGNSourceAttributeReferenceResolver = new org.emftext.language.refactoring.specification.resource.analysis.ASSIGNSourceAttributeReferenceResolver();
	protected org.emftext.language.refactoring.specification.resource.analysis.ASSIGNTargetAttributeReferenceResolver aSSIGNTargetAttributeReferenceResolver = new org.emftext.language.refactoring.specification.resource.analysis.ASSIGNTargetAttributeReferenceResolver();
	protected org.emftext.language.refactoring.specification.resource.analysis.VariableReferenceVariableReferenceResolver variableReferenceVariableReferenceResolver = new org.emftext.language.refactoring.specification.resource.analysis.VariableReferenceVariableReferenceResolver();
	protected org.emftext.language.refactoring.specification.resource.analysis.RoleReferenceRoleReferenceResolver roleReferenceRoleReferenceResolver = new org.emftext.language.refactoring.specification.resource.analysis.RoleReferenceRoleReferenceResolver();
	protected org.emftext.language.refactoring.specification.resource.analysis.TRACERoleReferenceResolver tRACERoleReferenceResolver = new org.emftext.language.refactoring.specification.resource.analysis.TRACERoleReferenceResolver();
	protected org.emftext.language.refactoring.specification.resource.analysis.CollaborationReferenceCollaborationReferenceResolver collaborationReferenceCollaborationReferenceResolver = new org.emftext.language.refactoring.specification.resource.analysis.CollaborationReferenceCollaborationReferenceResolver();
	protected org.emftext.language.refactoring.specification.resource.analysis.RoleRemovalRoleReferenceResolver roleRemovalRoleReferenceResolver = new org.emftext.language.refactoring.specification.resource.analysis.RoleRemovalRoleReferenceResolver();
	
	public org.emftext.language.refactoring.specification.resource.IRefspecReferenceResolver<org.emftext.language.refactoring.refactoring_specification.RefactoringSpecification, org.emftext.language.refactoring.roles.RoleModel> getRefactoringSpecificationUsedRoleModelReferenceResolver() {
		return getResolverChain(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getRefactoringSpecification_UsedRoleModel(), refactoringSpecificationUsedRoleModelReferenceResolver);
	}
	
	public org.emftext.language.refactoring.specification.resource.IRefspecReferenceResolver<org.emftext.language.refactoring.refactoring_specification.CREATE, org.emftext.language.refactoring.roles.Role> getCREATESourceRoleReferenceResolver() {
		return getResolverChain(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCREATE_SourceRole(), cREATESourceRoleReferenceResolver);
	}
	
	public org.emftext.language.refactoring.specification.resource.IRefspecReferenceResolver<org.emftext.language.refactoring.refactoring_specification.ContainmentCommand, org.emftext.language.refactoring.refactoring_specification.IndexVariable> getContainmentCommandIndexReferenceResolver() {
		return getResolverChain(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getContainmentCommand_Index(), containmentCommandIndexReferenceResolver);
	}
	
	public org.emftext.language.refactoring.specification.resource.IRefspecReferenceResolver<org.emftext.language.refactoring.refactoring_specification.ASSIGN, org.emftext.language.refactoring.roles.RoleAttribute> getASSIGNSourceAttributeReferenceResolver() {
		return getResolverChain(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getASSIGN_SourceAttribute(), aSSIGNSourceAttributeReferenceResolver);
	}
	
	public org.emftext.language.refactoring.specification.resource.IRefspecReferenceResolver<org.emftext.language.refactoring.refactoring_specification.ASSIGN, org.emftext.language.refactoring.roles.RoleAttribute> getASSIGNTargetAttributeReferenceResolver() {
		return getResolverChain(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getASSIGN_TargetAttribute(), aSSIGNTargetAttributeReferenceResolver);
	}
	
	public org.emftext.language.refactoring.specification.resource.IRefspecReferenceResolver<org.emftext.language.refactoring.refactoring_specification.VariableReference, org.emftext.language.refactoring.refactoring_specification.Variable> getVariableReferenceVariableReferenceResolver() {
		return getResolverChain(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference_Variable(), variableReferenceVariableReferenceResolver);
	}
	
	public org.emftext.language.refactoring.specification.resource.IRefspecReferenceResolver<org.emftext.language.refactoring.refactoring_specification.RoleReference, org.emftext.language.refactoring.roles.Role> getRoleReferenceRoleReferenceResolver() {
		return getResolverChain(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getRoleReference_Role(), roleReferenceRoleReferenceResolver);
	}
	
	public org.emftext.language.refactoring.specification.resource.IRefspecReferenceResolver<org.emftext.language.refactoring.refactoring_specification.TRACE, org.emftext.language.refactoring.roles.Role> getTRACERoleReferenceResolver() {
		return getResolverChain(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getTRACE_Role(), tRACERoleReferenceResolver);
	}
	
	public org.emftext.language.refactoring.specification.resource.IRefspecReferenceResolver<org.emftext.language.refactoring.refactoring_specification.CollaborationReference, org.emftext.language.refactoring.roles.MultiplicityCollaboration> getCollaborationReferenceCollaborationReferenceResolver() {
		return getResolverChain(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCollaborationReference_Collaboration(), collaborationReferenceCollaborationReferenceResolver);
	}
	
	public org.emftext.language.refactoring.specification.resource.IRefspecReferenceResolver<org.emftext.language.refactoring.refactoring_specification.RoleRemoval, org.emftext.language.refactoring.roles.Role> getRoleRemovalRoleReferenceResolver() {
		return getResolverChain(org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getRoleRemoval_Role(), roleRemovalRoleReferenceResolver);
	}
	
	public void setOptions(java.util.Map<?, ?> options) {
		if (options != null) {
			this.options = new java.util.LinkedHashMap<Object, Object>();
			this.options.putAll(options);
		}
		refactoringSpecificationUsedRoleModelReferenceResolver.setOptions(options);
		cREATESourceRoleReferenceResolver.setOptions(options);
		containmentCommandIndexReferenceResolver.setOptions(options);
		aSSIGNSourceAttributeReferenceResolver.setOptions(options);
		aSSIGNTargetAttributeReferenceResolver.setOptions(options);
		variableReferenceVariableReferenceResolver.setOptions(options);
		roleReferenceRoleReferenceResolver.setOptions(options);
		tRACERoleReferenceResolver.setOptions(options);
		collaborationReferenceCollaborationReferenceResolver.setOptions(options);
		roleRemovalRoleReferenceResolver.setOptions(options);
	}
	
	public void resolveFuzzy(String identifier, org.eclipse.emf.ecore.EObject container, org.eclipse.emf.ecore.EReference reference, int position, org.emftext.language.refactoring.specification.resource.IRefspecReferenceResolveResult<org.eclipse.emf.ecore.EObject> result) {
		if (container == null) {
			return;
		}
		if (org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getRefactoringSpecification().isInstance(container)) {
			RefspecFuzzyResolveResult<org.emftext.language.refactoring.roles.RoleModel> frr = new RefspecFuzzyResolveResult<org.emftext.language.refactoring.roles.RoleModel>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("usedRoleModel")) {
				refactoringSpecificationUsedRoleModelReferenceResolver.resolve(identifier, (org.emftext.language.refactoring.refactoring_specification.RefactoringSpecification) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
		if (org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCREATE().isInstance(container)) {
			RefspecFuzzyResolveResult<org.emftext.language.refactoring.roles.Role> frr = new RefspecFuzzyResolveResult<org.emftext.language.refactoring.roles.Role>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("sourceRole")) {
				cREATESourceRoleReferenceResolver.resolve(identifier, (org.emftext.language.refactoring.refactoring_specification.CREATE) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
		if (org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getContainmentCommand().isInstance(container)) {
			RefspecFuzzyResolveResult<org.emftext.language.refactoring.refactoring_specification.IndexVariable> frr = new RefspecFuzzyResolveResult<org.emftext.language.refactoring.refactoring_specification.IndexVariable>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("index")) {
				containmentCommandIndexReferenceResolver.resolve(identifier, (org.emftext.language.refactoring.refactoring_specification.ContainmentCommand) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
		if (org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getASSIGN().isInstance(container)) {
			RefspecFuzzyResolveResult<org.emftext.language.refactoring.roles.RoleAttribute> frr = new RefspecFuzzyResolveResult<org.emftext.language.refactoring.roles.RoleAttribute>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("sourceAttribute")) {
				aSSIGNSourceAttributeReferenceResolver.resolve(identifier, (org.emftext.language.refactoring.refactoring_specification.ASSIGN) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
		if (org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getASSIGN().isInstance(container)) {
			RefspecFuzzyResolveResult<org.emftext.language.refactoring.roles.RoleAttribute> frr = new RefspecFuzzyResolveResult<org.emftext.language.refactoring.roles.RoleAttribute>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("targetAttribute")) {
				aSSIGNTargetAttributeReferenceResolver.resolve(identifier, (org.emftext.language.refactoring.refactoring_specification.ASSIGN) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
		if (org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference().isInstance(container)) {
			RefspecFuzzyResolveResult<org.emftext.language.refactoring.refactoring_specification.Variable> frr = new RefspecFuzzyResolveResult<org.emftext.language.refactoring.refactoring_specification.Variable>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("variable")) {
				variableReferenceVariableReferenceResolver.resolve(identifier, (org.emftext.language.refactoring.refactoring_specification.VariableReference) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
		if (org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getRoleReference().isInstance(container)) {
			RefspecFuzzyResolveResult<org.emftext.language.refactoring.roles.Role> frr = new RefspecFuzzyResolveResult<org.emftext.language.refactoring.roles.Role>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("role")) {
				roleReferenceRoleReferenceResolver.resolve(identifier, (org.emftext.language.refactoring.refactoring_specification.RoleReference) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
		if (org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getTRACE().isInstance(container)) {
			RefspecFuzzyResolveResult<org.emftext.language.refactoring.roles.Role> frr = new RefspecFuzzyResolveResult<org.emftext.language.refactoring.roles.Role>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("role")) {
				tRACERoleReferenceResolver.resolve(identifier, (org.emftext.language.refactoring.refactoring_specification.TRACE) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
		if (org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCollaborationReference().isInstance(container)) {
			RefspecFuzzyResolveResult<org.emftext.language.refactoring.roles.MultiplicityCollaboration> frr = new RefspecFuzzyResolveResult<org.emftext.language.refactoring.roles.MultiplicityCollaboration>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("collaboration")) {
				collaborationReferenceCollaborationReferenceResolver.resolve(identifier, (org.emftext.language.refactoring.refactoring_specification.CollaborationReference) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
		if (org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getRoleRemoval().isInstance(container)) {
			RefspecFuzzyResolveResult<org.emftext.language.refactoring.roles.Role> frr = new RefspecFuzzyResolveResult<org.emftext.language.refactoring.roles.Role>(result);
			String referenceName = reference.getName();
			org.eclipse.emf.ecore.EStructuralFeature feature = container.eClass().getEStructuralFeature(referenceName);
			if (feature != null && feature instanceof org.eclipse.emf.ecore.EReference && referenceName != null && referenceName.equals("role")) {
				roleRemovalRoleReferenceResolver.resolve(identifier, (org.emftext.language.refactoring.refactoring_specification.RoleRemoval) container, (org.eclipse.emf.ecore.EReference) feature, position, true, frr);
			}
		}
	}
	
	public org.emftext.language.refactoring.specification.resource.IRefspecReferenceResolver<? extends org.eclipse.emf.ecore.EObject, ? extends org.eclipse.emf.ecore.EObject> getResolver(org.eclipse.emf.ecore.EStructuralFeature reference) {
		if (reference == org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getRefactoringSpecification_UsedRoleModel()) {
			return getResolverChain(reference, refactoringSpecificationUsedRoleModelReferenceResolver);
		}
		if (reference == org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCREATE_SourceRole()) {
			return getResolverChain(reference, cREATESourceRoleReferenceResolver);
		}
		if (reference == org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getContainmentCommand_Index()) {
			return getResolverChain(reference, containmentCommandIndexReferenceResolver);
		}
		if (reference == org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getASSIGN_SourceAttribute()) {
			return getResolverChain(reference, aSSIGNSourceAttributeReferenceResolver);
		}
		if (reference == org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getASSIGN_TargetAttribute()) {
			return getResolverChain(reference, aSSIGNTargetAttributeReferenceResolver);
		}
		if (reference == org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getVariableReference_Variable()) {
			return getResolverChain(reference, variableReferenceVariableReferenceResolver);
		}
		if (reference == org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getRoleReference_Role()) {
			return getResolverChain(reference, roleReferenceRoleReferenceResolver);
		}
		if (reference == org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getTRACE_Role()) {
			return getResolverChain(reference, tRACERoleReferenceResolver);
		}
		if (reference == org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getCollaborationReference_Collaboration()) {
			return getResolverChain(reference, collaborationReferenceCollaborationReferenceResolver);
		}
		if (reference == org.emftext.language.refactoring.refactoring_specification.RefactoringSpecificationPackage.eINSTANCE.getRoleRemoval_Role()) {
			return getResolverChain(reference, roleRemovalRoleReferenceResolver);
		}
		return null;
	}
	
	@SuppressWarnings({"rawtypes", "unchecked"})	
	public <ContainerType extends org.eclipse.emf.ecore.EObject, ReferenceType extends org.eclipse.emf.ecore.EObject> org.emftext.language.refactoring.specification.resource.IRefspecReferenceResolver<ContainerType, ReferenceType> getResolverChain(org.eclipse.emf.ecore.EStructuralFeature reference, org.emftext.language.refactoring.specification.resource.IRefspecReferenceResolver<ContainerType, ReferenceType> originalResolver) {
		if (options == null) {
			return originalResolver;
		}
		Object value = options.get(org.emftext.language.refactoring.specification.resource.IRefspecOptions.ADDITIONAL_REFERENCE_RESOLVERS);
		if (value == null) {
			return originalResolver;
		}
		if (!(value instanceof java.util.Map)) {
			// send this to the error log
			new org.emftext.language.refactoring.specification.resource.util.RefspecRuntimeUtil().logWarning("Found value with invalid type for option " + org.emftext.language.refactoring.specification.resource.IRefspecOptions.ADDITIONAL_REFERENCE_RESOLVERS + " (expected " + java.util.Map.class.getName() + ", but was " + value.getClass().getName() + ")", null);
			return originalResolver;
		}
		java.util.Map<?,?> resolverMap = (java.util.Map<?,?>) value;
		Object resolverValue = resolverMap.get(reference);
		if (resolverValue == null) {
			return originalResolver;
		}
		if (resolverValue instanceof org.emftext.language.refactoring.specification.resource.IRefspecReferenceResolver) {
			org.emftext.language.refactoring.specification.resource.IRefspecReferenceResolver replacingResolver = (org.emftext.language.refactoring.specification.resource.IRefspecReferenceResolver) resolverValue;
			if (replacingResolver instanceof org.emftext.language.refactoring.specification.resource.IRefspecDelegatingReferenceResolver) {
				// pass original resolver to the replacing one
				((org.emftext.language.refactoring.specification.resource.IRefspecDelegatingReferenceResolver) replacingResolver).setDelegate(originalResolver);
			}
			return replacingResolver;
		} else if (resolverValue instanceof java.util.Collection) {
			java.util.Collection replacingResolvers = (java.util.Collection) resolverValue;
			org.emftext.language.refactoring.specification.resource.IRefspecReferenceResolver replacingResolver = originalResolver;
			for (Object next : replacingResolvers) {
				if (next instanceof org.emftext.language.refactoring.specification.resource.IRefspecReferenceCache) {
					org.emftext.language.refactoring.specification.resource.IRefspecReferenceResolver nextResolver = (org.emftext.language.refactoring.specification.resource.IRefspecReferenceResolver) next;
					if (nextResolver instanceof org.emftext.language.refactoring.specification.resource.IRefspecDelegatingReferenceResolver) {
						// pass original resolver to the replacing one
						((org.emftext.language.refactoring.specification.resource.IRefspecDelegatingReferenceResolver) nextResolver).setDelegate(replacingResolver);
					}
					replacingResolver = nextResolver;
				} else {
					// The collection contains a non-resolver. Send a warning to the error log.
					new org.emftext.language.refactoring.specification.resource.util.RefspecRuntimeUtil().logWarning("Found value with invalid type in value map for option " + org.emftext.language.refactoring.specification.resource.IRefspecOptions.ADDITIONAL_REFERENCE_RESOLVERS + " (expected " + org.emftext.language.refactoring.specification.resource.IRefspecDelegatingReferenceResolver.class.getName() + ", but was " + next.getClass().getName() + ")", null);
				}
			}
			return replacingResolver;
		} else {
			// The value for the option ADDITIONAL_REFERENCE_RESOLVERS has an unknown type.
			new org.emftext.language.refactoring.specification.resource.util.RefspecRuntimeUtil().logWarning("Found value with invalid type in value map for option " + org.emftext.language.refactoring.specification.resource.IRefspecOptions.ADDITIONAL_REFERENCE_RESOLVERS + " (expected " + org.emftext.language.refactoring.specification.resource.IRefspecDelegatingReferenceResolver.class.getName() + ", but was " + resolverValue.getClass().getName() + ")", null);
			return originalResolver;
		}
	}
	
}
