/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.emftext.language.refactoring.specification.resource.mopp;

public class RefspecTokenStyleInformationProvider {
	
	public static String TASK_ITEM_TOKEN_NAME = "TASK_ITEM";
	
	public org.emftext.language.refactoring.specification.resource.IRefspecTokenStyle getDefaultTokenStyle(String tokenName) {
		if ("ML_COMMENT".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x00, 0x80, 0x00}, null, false, true, false, false);
		}
		if ("REFACTORING".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x7F, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("FOR".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x7F, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("STEPS".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x7F, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("create".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x7F, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("remove".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x7F, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("new".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x7F, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("in".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x7F, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("move".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x7F, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("to".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x7F, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("set".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x7F, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("use".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x7F, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("index".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x7F, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("of".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x7F, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("assign".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x7F, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("for".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x7F, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("from".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x7F, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("uptree".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x50, 0xF0, 0x5C}, null, true, false, false, false);
		}
		if ("path".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x50, 0xF0, 0x5C}, null, true, false, false, false);
		}
		if ("filter".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x50, 0xF0, 0x5C}, null, true, false, false, false);
		}
		if ("trace".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x50, 0xF0, 0x5C}, null, true, false, false, false);
		}
		if ("first".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x50, 0xF0, 0x5C}, null, true, false, false, false);
		}
		if ("last".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x50, 0xF0, 0x5C}, null, true, false, false, false);
		}
		if ("after".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x50, 0xF0, 0x5C}, null, true, false, false, false);
		}
		if ("as".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x7F, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("distinct".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x7F, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("unused".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x7F, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("empty".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x7F, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("DOT_NOTATION".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x00, 0x00, 0xFF}, null, false, false, false, false);
		}
		if ("LOWER_IDENTIFIER".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x00, 0x00, 0xFF}, null, false, false, false, false);
		}
		if ("UPPER_IDENTIFIER".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x00, 0x00, 0xFF}, null, false, false, false, false);
		}
		if ("CONSTANTS".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0xFF, 0x80, 0x00}, null, true, false, false, false);
		}
		if ("at".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("object".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x80, 0x00, 0x55}, null, true, false, false, false);
		}
		if ("QUOTED_60_62".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x2A, 0x00, 0xFF}, null, false, false, false, false);
		}
		if ("TASK_ITEM".equals(tokenName)) {
			return new org.emftext.language.refactoring.specification.resource.mopp.RefspecTokenStyle(new int[] {0x7F, 0x9F, 0xBF}, null, true, false, false, false);
		}
		return null;
	}
	
}
