/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.emftext.language.refactoring.specification.resource.ui;

public class RefspecUIMetaInformation extends org.emftext.language.refactoring.specification.resource.mopp.RefspecMetaInformation {
	
	public org.emftext.language.refactoring.specification.resource.IRefspecHoverTextProvider getHoverTextProvider() {
		return new org.emftext.language.refactoring.specification.resource.ui.RefspecHoverTextProvider();
	}
	
	public org.emftext.language.refactoring.specification.resource.ui.RefspecImageProvider getImageProvider() {
		return org.emftext.language.refactoring.specification.resource.ui.RefspecImageProvider.INSTANCE;
	}
	
	public org.emftext.language.refactoring.specification.resource.ui.RefspecColorManager createColorManager() {
		return new org.emftext.language.refactoring.specification.resource.ui.RefspecColorManager();
	}
	
	/**
	 * @deprecated this method is only provided to preserve API compatibility. Use
	 * createTokenScanner(org.emftext.language.refactoring.specification.resource.IRefs
	 * pecTextResource,
	 * org.emftext.language.refactoring.specification.resource.ui.RefspecColorManager)
	 * instead.
	 */
	public org.emftext.language.refactoring.specification.resource.ui.RefspecTokenScanner createTokenScanner(org.emftext.language.refactoring.specification.resource.ui.RefspecColorManager colorManager) {
		return createTokenScanner(null, colorManager);
	}
	
	public org.emftext.language.refactoring.specification.resource.ui.RefspecTokenScanner createTokenScanner(org.emftext.language.refactoring.specification.resource.IRefspecTextResource resource, org.emftext.language.refactoring.specification.resource.ui.RefspecColorManager colorManager) {
		return new org.emftext.language.refactoring.specification.resource.ui.RefspecTokenScanner(resource, colorManager);
	}
	
	public org.emftext.language.refactoring.specification.resource.ui.RefspecCodeCompletionHelper createCodeCompletionHelper() {
		return new org.emftext.language.refactoring.specification.resource.ui.RefspecCodeCompletionHelper();
	}
	
}
